 	MODULE sparms
! ==========================================================
!   Array and global variable declarations
!	for use in evaluating function
! ==========================================================
	implicit none
	integer,dimension(:),   allocatable   :: ntypat,nzt
	integer,dimension(:),   allocatable   :: kx,ky,kz
	integer,dimension(:,:,:),allocatable :: lattice
	real,dimension (:),     allocatable   :: x,y,z
	real,dimension (:),     allocatable   :: sigx, sigy,sigz
	real,dimension (:),     allocatable   :: rmt,vx,vy,vz,scthet
	integer ::		 arrdim(19),mode(8),gradopt
   	integer ::		nat,nan,nel,ngx,ngy,ngz,nx1,ny1,nz1,iat,ian
   	integer ::		zi,iel,nzi,ntypov
	integer	::		numb,ndate,scaleopt
	real::			xper,yper
	real::			cor_cof, cor_dis, cor_red, cor_re3
	real::			cov,def_rms
	real::			phi, thet, thet2,chthet
	real::			energy
	real::			rmi
	real::			degrad,pi
	real::			coulomb,scrlen,fluxc,fluxb,factor,step
! =================================================================
! Variables need to define multimodel and output values
! =================================================================
	integer :: max_parms,max_points,max_atoms,max_angle,max_nel
	integer :: max_files,iout
	parameter(max_parms  =  50)
	parameter(max_points =   9)
	parameter(max_atoms  = 300)
	parameter(max_angle  = 400)
	parameter(max_nel    =   6)		
	parameter(max_files  =  18)
	parameter(iout       =  20)			
	real,dimension(max_atoms*(max_points+1)):: rel_x,rel_y,rel_z,vibra
	real		:: valstr(max_points), valvib(max_points)
	integer		:: matstr(max_points), matvib(max_points)
   	integer		:: nvalst,nvalvi
	integer		:: nst,nvi,nps,npv,nas,nav,mps,mpv,mas,mav

!========================================================
!	Basic parameters used in bfgs search
!	by r-factor subroutines
!========================================================
   	integer					:: nfunc,ngrad,nfiles,nelem,npoints,ndomain
 	integer					:: nparms,skewopt
	real,dimension (:,:),allocatable	:: dx,dy,dz,dsx,dsy,dsz
    	integer,dimension (:),allocatable	:: naff
	integer,dimension(:),allocatable        :: incy,calflag
	real,dimension (:),allocatable		:: weighty,calval,calper,xguess
	real,dimension (:),allocatable		:: xlb,xub,gstep
	real								:: xtol,rftol,gtol
	character(80),dimension(:),allocatable ::	base
	character(80),dimension(:),allocatable :: expt
	character(20),dimension(:),allocatable :: pnames
	character(80)						   :: statfile


	END MODULE sparms

program bfgstest
! ============================================================
!  
!  Program 
!
! ============================================================
use sparms
use search1
logical start
external ftn,gradf,rftn

call readparms
open  (iout, file ="status.dat",status = 'unknown')
	write(iout,*) 'Starting Search'
close(iout)   
start=.true.
scaleopt=1.0
call domin(nparms,xguess,ftn,gradf,rftn,rftol,6,start,scaleopt)


end program bfgstest





	subroutine readparms
!   =============================================================
!
!    Readin the search parameter from "bfgsin.dat"
!
!   =============================================================
	use sparms
	implicit none
	logical exists
	integer i,j

    INQUIRE(FILE='bfgsin.dat',EXIST=EXISTS)
	IF(.NOT.EXISTS) THEN
	   WRITE(*,'(1X,2A)') 'FILE BFGSIN.DAT DOES NOT EXIST'
	PAUSE
	STOP
	END IF 
	OPEN(UNIT=2,FILE='bfgsin.dat',STATUS='OLD')

    READ(2,'(1X,I3)') NFILES
    WRITE(*,'(1X,A,I3,A)') 'THERE ARE',NFILES,'DATA SETS'
	allocate (base(nfiles))
	allocate (expt(nfiles))
	allocate (calflag(nfiles))
	allocate (calval(nfiles))
	allocate (calper(nfiles))

	DO I=1,NFILES
	  READ(2,'(1X,A)') EXPT(I)
	  WRITE(*,'(1X,A)') EXPT(I)	  
      	  INQUIRE(FILE=EXPT(I),EXIST=EXISTS)
	  IF(.NOT.EXISTS) THEN
	    WRITE(*,'(1X,3A)') 'EXPT FILE ',EXPT(I),'DOES NOT EXIST'
	    PAUSE
	    STOP
          END IF 
 	  READ(2,'(1X,I3)') CALFLAG(I)
	  WRITE(6,*) CALFLAG(I)
	  IF(CALFLAG(I).EQ.1) THEN
	  	READ(2,'(1X,2F6.2)') CALVAL(I),CALPER(I)
	  END IF
	  
 	  READ(2,'(1X,A)') base(I)
 	  WRITE(*,'(A)') base(I)
		  INQUIRE(FILE=base(I),EXIST=EXISTS)
		  IF(.NOT.EXISTS) THEN
		     WRITE(*,'(1X,3A)') 'BASE FILE ',BASE(I),'DOES NOT EXIST'
		  PAUSE
		  STOP
	  	END IF 
	  END DO	

	READ(2,'(1X,A)')  STATFILE
	WRITE(6,*) STATFILE
	READ(2,'(1X,I3)')  NELEM
	allocate (incy(nfiles))
	allocate (weighty(nfiles))
	WRITE(6,'(1X,A,I3)')   'NO OF ELEMENTS                 :',NELEM	
	DO I=1,NELEM
		READ(2,'(1X,I3,F8.3)') INCY(I),WEIGHTY(I)
	WRITE(6,'(1X,A,I3,F8.3)') 'INCLUDE AND WEIGHT	 		  :',INCY(I),WEIGHTY(I)
	END DO

	READ(2,'(1X,F6.4)') RFTOL
	READ(2,'(1X,I3)')   NPOINTS
	IF(NPOINTS>9) then
		write(6,'(1X,A)') 'DONT BE STUPID 9 PINTS IS ENOUGH FOR ANY MAN'
		stop
	end if
	READ(2,'(1X,I3)')   SCALEOPT
        WRITE(6,*)  'Scaling option',scaleopt
	READ(2,'(1X,I3)')  nparms
	WRITE(6,'(1X,A,I3)')   'NUMBER OF PARAMETERS		   :',NPARMS
	WRITE(6,'(1X,A,F8.3)') 'RELATIVE TOLERANCE			   :',RFTOL
	WRITE(6,'(1X,A,I3)')   'NO. OF POINTS IN RFACTOR CURVE :',NPOINTS

	allocate(gstep(nparms))
	allocate(xguess(nparms))
	allocate(naff(nparms))
	allocate(dx(nparms,300),dy(nparms,300),dz(nparms,300))
	allocate(dsx(nparms,300),dsy(nparms,300),dsz(nparms,300))
	allocate(pnames(nparms))
 	DO i=1,nparms
	READ(2,'(1X,A)') PNAMES(I)	
	WRITE(6,'(1X,2A)')     'PARAMETER NAME                 :', PNAMES(I)	
	READ(2,'(1X,2F8.3)') Xguess(i),gstep(i)
	WRITE(6,'(1X,A,2F8.3)') 'GUESS AND GRADIENT STEP SIZE   :',XGUESS(I),GSTEP(I)
	READ(2,'(1X,I3)') naff(i)
 	  DO j=1,naff(i)
	   READ(2,'(1X,6F7.3)')  dx(i,j),dy(i,j),dz(i,j), &
     &				 dsx(i,j),dsy(i,j),dsz(i,j)
	   write(*,'(1X,6F7.3)')  dx(i,j),dy(i,j),dz(i,j), &
     &				 dsx(i,j),dsy(i,j),dsz(i,j)

	  END DO		
	END DO

	write(6,'(1X,A)') 'Parameters Successfully read-in'	
	
    CLOSE(2)
	


	end subroutine readparms 




	subroutine gradf(n,xin,gd,gd2,err) 
! ================================================
! SUBROUTINE TO GENERATE THE GRADIENT OF THE 
! MEIS R-FACTOR
! using multimodel
! =================================================
	use sparms
	use rfactor
	use multicalc_code
! Local Variables
	integer		i,k
	integer		n,j,centre
	real		gd(n),gd2(n),ftot(max_points),funct(max_parms,max_points)	
	real		xin(n),ff(max_files,max_points),angles(max_points),poly(4)
	real		xtmp(max_parms),xmin(40),sigma(40)
	real		avf,sumang	
 	character*80 in,out,skew
	character*4  skewnum
	character*1  filenum

!  Bfgs stuff
	integer			nangles(max_files)
	logical			err

	err = .false.
    ngrad=ngrad+1  
	in  = 'inmulti.in'

	if (err) return
	do k=1,n
 		do j=1,n
	  		xtmp(j)=xin(j)
		end do	
		do j=1,nfiles 	
				write(filenum,'(I1)') j
				out = 'out'//filenum
				call altermulti(xtmp,k,base(j),in)
				call multicalc(in,out)
				nangles(j)=nan
				do i=1,npoints
				write (skewnum,'(I4)') i
       	        		skewnum(1:3) = '000'
				out = 'out'//filenum//'.'//skewnum

				skew='skew'//filenum//'.'//skewnum
				call meis_rfactor(ff(j,i),out,expt(j),	&
								skew,0,nelem,		    &
								incy,weighty,n_angles,	&
								calflag(j),calval(j),calper(j))
				end do
		end do

		do i=1,npoints
			avf    = 0.0
			sumang = 0.0
			do j=1,nfiles		
				  avf=avf+nangles(j)*ff(j,i)	
				  sumang = sumang+nangles(j)
		  	end do
			avf=avf/sumang
			ftot(i)=avf		  	
			funct(k,i)=ftot(i)
		end do

		centre=(npoints+1)/2
		do i=1,npoints
			angles(i)= i
		end do
		CALL FITPOLY(ftot,ANGLES,NPOINTS,POLY)
		call errmin(n,angles,poly,xmin(k),sigma(k))		
		
		xmin(k)  = (xmin(k)-centre)*gstep(k)
		sigma(k) =  sigma(k)*gstep(k)

		gd(k)=(ftot(centre-2)-(8*ftot(centre-1))				&
	&		+(8*ftot(centre+1))-ftot(centre+2))/(12*gstep(k))	
			gd2(k)=( ftot(centre-1) - (2.0*ftot(centre))		&
	&	       +ftot(centre+1) ) / (gstep(k)**2)
		write(*,*) 'der 2der ',gd(k),gd2(k)
	      
		open (iout, file = 'rfactor2.dat', status = 'unknown')
		do i=1,npoints
	   		write(iout,'(1X,F8.3)') ftot(i)
	   	end do
       	close (iout)
  	    
		end do 

       open (iout, file = 'rfactor.dat', status = 'unknown')
	   do i=1,npoints
	   write(iout,'(30(1X,F8.3))') (funct(k,i),k=1,n)
	   end do
       close (iout)
	   open (iout, file = "status.dat", status = 'old'	&
	&		     , position = 'append')

        write(iout,'(1X,A,I3)') 'GRADIENT EVALUATION No.:',ngrad
        write(6,'(1X,A,I3)') 'GRADIENT EVALUATION No.:',ngrad
	DO i=1,n
	 WRITE(iout,'(1X,A,1X,A,F8.3)') ' PARM :',PNAMES(I),XIN(I)
	 WRITE(6,'(1X,A,1X,A,F8.3)') ' PARM :',PNAMES(I),XIN(I)
 	END DO
	DO i=1,n
	 WRITE(iout,'(1X,1A,1X,3F8.3)') 'X,DX AND ERR :',XIN(I),XMIN(I),SIGMA(I)
	 WRITE(6,'(1X,1A,1X,3F8.3)') 'X,DX AND ERR :',XIN(I),XMIN(I),SIGMA(I)
 	END DO
	do k=1,n
        write(iout,'(1X,A,2F12.3)') 'GRADIENT :',gd(k),gd2(k)
        write(6,'(1X,A,2F12.3)') 'grad F 2nd Der ', gd(k),gd2(k)
	end do
    close (iout)


	return  
	end subroutine gradf




	subroutine ftn(n,xd,fx,err) 
! ================================================
! SUBROUTINE TO GENERATE THE GRADIENT OF THE 
! MEIS R-FACTOR
! using multimodel
! =================================================
	use sparms
	use rfactor
	use multicalc_code
! Local Variables
!
	integer		i
	integer		n,j
	real		xd(n),ff(max_files,max_parms),fx
	real		ftot(max_points)
	real		xtmp(max_parms)
	real		avf,sumang	
 	character*80 in,out,skew
	character*4  skewnum
	character*1  filenum


!
!  Bfgs stuff
!

	integer		nangles(max_files)	
	logical		err

	err		=  .false.
    nfunc	=  nfunc+1  
	in		= 'inmulti.in'

	if (err) return

		do j=1,n
	  		   xtmp(j)=xd(j)
	  		   write(*,*) 
   		end do	
		do j=1,nfiles 	
			write(filenum,'(I1)') j		
			out = 'out'//filenum
			call altermulti(xtmp,1,base(j),in)
			call multicalc(in,out)
			nangles(j)=nan
			do i=1,npoints
				write (skewnum,'(I4)') i
       	        		skewnum(1:3) = '000'
		
				out = 'out'//filenum//'.'//skewnum
				skew='skew'//filenum//'.'//skewnum
				call meis_rfactor(ff(j,i),out,expt(j),	&
								skew,0,nelem,		    &
								incy,weighty,n_angles,	&
								calflag(j),calval(j),calper(J))
			end do
		end do

		do i=1,npoints
			avf=0.0
			sumang=0.0
			do j=1,nfiles		
				  avf=avf+nangles(j)*ff(j,i)	
				  sumang = sumang+nangles(j)
		  	end do
			avf=avf/sumang
			ftot(i)=avf		  	
		end do

	   fx=ftot(((npoints+1)/2))
       open (iout, file = 'rfactor2.dat', status = 'unknown')
	   do i=1,npoints
	   write(iout,'(1X,F8.3)') ftot(i)
	   end do
       close (iout)

! ==================================================
! OUTPUT TO STATUS FILE
! ==================================================      
      open  (iout, file = "status.dat", status = 'old'  &
     &        , position = 'append')
	WRITE(iout,*) ' FUNCTION EVALUATION NO:',NFUNC
	WRITE(6,*) ' FUNCTION EVALUATION NO:',NFUNC
	WRITE(6,*) ' R-FACTOR:',FX
	WRITE(iout,*) ' R-FACTOR:',FX
	DO i=1,n
	 WRITE(iout,'(1X,A,1X,A,F8.3)') ' PARM :',PNAMES(I),XD(I)
	 WRITE(6,'(1X,A,1X,A,F8.3)') ' PARM :',PNAMES(I),XD(I)
	END DO

    CLOSE(iout)
	return  
	end subroutine ftn







SUBROUTINE MMODEL(multype,naf,delx,dely,delz,mulstep) 
! Modified by Paul Quinn for use in bfgs algorithm
!*******************************************************************************
!       MM    MM  U    U  LL      TTTTTT  IIIIII  MM    MM   OOOO   DDDDD      *
!       M M  M M  U    U  LL        TT      II    M M  M M  O    O  D    D     *
!       M  MM  M  U    U  LL        TT      II    M  MM  M  O    O  D    D     *
!       M      M  U    U  LL        TT      II    M      M  O    O  D    D  ...*
!       M      M   UUUU   LLLLLL    TT    IIIIII  M      M   OOOO   DDDDD   ...*
!*******************************************************************************
	use sparms
	implicit none
	integer		:: multype,ipv,i,ndis,naf,j
	real		:: delx(naf),dely(naf),delz(naf)
	integer		:: i_aid,ntimes
	integer		:: jx,jy,jz,ivalvi,ist,ivalst,ivi
	real		:: relmax(max_atoms), vibmax(max_atoms)
	real		:: rxmin,rymin,rzmin
	real		:: rxmax,rymax,rzmax
	real		:: terpol,mulstep
	real,dimension(:), allocatable			:: aver_x,aver_y,aver_z
	real,dimension(:), allocatable			:: natx,naty,natz
	real,dimension(:), allocatable			:: delta_x,delta_y,delta_z
	real,dimension (:,:),allocatable		:: disx,disy,disz
	real,dimension (:,:),allocatable		:: v
	integer,dimension(:,:,:), allocatable		:: ixyz
	integer,dimension(:), allocatable		:: istr,ivib

 
!		itry=6*nat
	allocate(aver_x(nat),aver_y(nat),aver_z(nat))
	allocate(natx(ngx),naty(ngy),natz(ngz))
	allocate(delta_x(ngx),delta_y(ngy),delta_z(ngz))
	allocate(disx(nat,2),disy(nat,2),disz(nat,2))
	allocate(v(nat,2))
	allocate(ixyz(ngx,ngy,ngz))
	allocate(istr(nat), ivib(nat))
!	allocate(rel_x(itry),rel_y(itry),rel_z(itry),vibra(itry)) 
! multype is 0 or 1 depending on if its a struture or vibration paramter

! Initialise various arrays to zero
        nst = 0
        nvi = 0
        nps = 0
        npv = 0
        nas = 0
        nav = 0
        mps = 0
        mpv = 0
        mas = 0
        mav = 0

        do iat = 1,nat
          relmax(iat)	= 0.
          vibmax(iat)	= sigx(iat)
          vibra(iat)	= sigx(iat)
        end do

          disx = 0.
          disy = 0.
          disz = 0.
		
          delta_x = 0.
          delta_y = 0.
          delta_z = 0.

	  rel_x = 0.0
	  rel_y = 0.0
	  rel_z = 0.0

          ixyz = 0
          natx = 0
          naty = 0
          natz = 0

        do iat = 1,nat
          ixyz(kx(iat), ky(iat), kz(iat)) = iat         !Auxiliary lattice
          natx(kx(iat)) = natx(kx(iat))+1               !# atoms in the
          naty(ky(iat)) = naty(ky(iat))+1               ! x, y and z-groups
          natz(kz(iat)) = natz(kz(iat))+1
        end do

! no. of strucutral parameters nps =1 at a time  		
! parameter name           namstr(ips)
! no of values for a parameter nvalst(ips)= 6
! first value valstr(1) ->last value valstr(nvalst)
	ntimes=(npoints-1)/2
	select case(multype)
	case(0)
			nps=1
			nvalst=npoints
			ntimes=(npoints-1)/2
			valstr(1)= -1*ntimes*mulstep
			valstr(npoints)= ntimes*mulstep
! Divide up into equal intervals
            do ivalst = 1,npoints
              valstr(ivalst) = valstr(1)	&
             +(ivalst-1)					&
             *(valstr(nvalst)-valstr(1))	&
             /(nvalst-1)
           end do
      
! atom affected list
          do i = 1,nat
            istr(i) = 0
          end do

!
! number of atoms affected naf 
            do i = 1,naf
			  if(abs(delx(i)).gt.0.0.or.abs(dely(i)).gt.0.0.or.abs(delz(i)).gt.0.0) then
				istr(i) = 1
			  end if
            end do

			disx=0.0
			disy=0.0
			disz=0.0

              do i = 1,naf
                if (istr(i) .eq. 1) then
! X min displacements
				disx(i,1)   = (delx(i)*(-ntimes*mulstep))	
! Y min displacements
                disy(i,1) =   (dely(i)*(-ntimes*mulstep))
! Z min displacements
                disz(i,1) =   (delz(i)*(-ntimes*mulstep))
! X max displacements
				disx(i,2)   = (delx(i)*(ntimes*mulstep))	
! Y max displacements
                disy(i,2) =   (dely(i)*(ntimes*mulstep))
! Z max displacements
                disz(i,2) =   (delz(i)*(ntimes*mulstep))

                else
                  disx(i,1) = 0.
                  disy(i,1) = 0.
                  disz(i,1) = 0.
                  disx(i,2) = 0.
                  disy(i,2) = 0.
                  disz(i,2) = 0.

                end if
              end do




        do j = 1,npoints
            matstr(j) = 0
        end do

        nst = 0

! ncombi total number of strucutres

! Loop 
          i_aid = 1
strloop: do i_aid=1,npoints 	
          nst = nst+1
          matstr(nst) = i_aid

          do iat = 1, nat
            rel_x(iat+nat*(nst-1)) = 0.
            rel_y(iat+nat*(nst-1)) = 0.
            rel_z(iat+nat*(nst-1)) = 0.
          end do

           terpol = (valstr(i_aid)		     &
                    -valstr(1) )			 &
                   /(valstr(nvalst)			 &
                    -valstr(1) )

            do iat = 1, nat
              rel_x(iat+nat*(nst-1)) = rel_x(iat+nat*(nst-1))		&
            +disx(iat,1)											&
           +(disx(iat,2)											&
            -disx(iat,1) )*terpol
              rel_y(iat+nat*(nst-1)) = rel_y(iat+nat*(nst-1))		&
            +disy(iat, 1)											&
            +(disy(iat,2)											&
            -disy(iat, 1) )*terpol
              rel_z(iat+nat*(nst-1)) = rel_z(iat+nat*(nst-1))		&
            +disz(iat, 1)											&
            +(disz(iat,2)											&
            -disz(iat, 1) )*terpol
            end do

! End loop 
		end do strloop


        do iat = 1, nat
          aver_x(iat) = 0.
          aver_y(iat) = 0.
          aver_z(iat) = 0.

          rxmin = rel_x(iat)
          rxmax = rel_x(iat)
          rymin = rel_y(iat)
          rymax = rel_y(iat)
          rzmin = rel_z(iat)
          rzmax = rel_z(iat)

          do ist = 1, nst
            rxmin = min(rxmin, rel_x(iat+nat*(ist-1)))
            rxmax = max(rxmax, rel_x(iat+nat*(ist-1)))
            rymin = min(rymin, rel_y(iat+nat*(ist-1)))
            rymax = max(rymax, rel_y(iat+nat*(ist-1)))
            rzmin = min(rzmin, rel_z(iat+nat*(ist-1)))
            rzmax = max(rzmax, rel_z(iat+nat*(ist-1)))
          end do

          aver_x(iat) = (rxmin+rxmax)/2.
          aver_y(iat) = (rymin+rymax)/2.
          aver_z(iat) = (rzmin+rzmax)/2.

          x(iat) = x(iat)+aver_x(iat)
          y(iat) = y(iat)+aver_y(iat)
          z(iat) = z(iat)+aver_z(iat)

          do ist = 1, nst
            rel_x(iat+nat*(ist-1)) = rel_x(iat+nat*(ist-1))-aver_x(iat)
            rel_y(iat+nat*(ist-1)) = rel_y(iat+nat*(ist-1))-aver_y(iat)
            rel_z(iat+nat*(ist-1)) = rel_z(iat+nat*(ist-1))-aver_z(iat)

            relmax(iat) = max(relmax(iat),		    &
                      rel_x(iat+nat*(ist-1))**2	    &
                     +rel_y(iat+nat*(ist-1))**2	    &
                     +rel_z(iat+nat*(ist-1))**2)

          end do

          delta_x(kx(iat)) = delta_x(kx(iat))+aver_x(iat)
          delta_y(ky(iat)) = delta_y(ky(iat))+aver_y(iat)
          delta_z(kz(iat)) = delta_z(kz(iat))+aver_z(iat)
        end do

        do jx = 1, ngx
          delta_x(jx) = delta_x(jx)/natx(jx)
        end do
        do jy = 1, ngy
          delta_y(jy) = delta_y(jy)/naty(jy)
        end do
        do jz = 1, ngz
          delta_z(jz) = delta_z(jz)/natz(jz)
        end do

        do jx = 2, ngx
          vx(jx) = vx(jx)+delta_x(jx)-delta_x(1)
        end do
        do jy = 2, ngy
          vy(jy) = vy(jy)+delta_y(jy)-delta_y(1)
        end do
        do jz = 2, ngz
          vz(jz) = vz(jz)+delta_z(jz)-delta_z(1)
        end do

        vx(1) = 0.
        vy(1) = 0.
        vz(1) = 0.

        do iat = 1, nat
          x(iat) = x(iat)-delta_x(1)
          y(iat) = y(iat)-delta_y(1)
          z(iat) = z(iat)-delta_z(1)
        end do

        do iat = 1, nat
          if (nst .gt. 1) then
            do ist = 2,nst
              if (rel_x(iat+nat*(ist-1)) .ne. rel_x(iat) .or.      &
               rel_y(iat+nat*(ist-1)) .ne. rel_y(iat) .or.		   &
               rel_z(iat+nat*(ist-1)) .ne. rel_z(iat)) nas = iat
            end do
          end if
        end do


	case(1)
! **********************************************
! **********************************************
!		Vibrations Setup 
! **********************************************
! **********************************************

! npv number of vibrations =  1 for us
! initialise to zero ivib array that describes which atoms affected

	write(*,*) 'naf',naf

        do iat = 1,nat
          ivib(iat) = 0
        end do
	npv =1

! namvib(ipv) name of vib parameter
! nvalvi(ipv) number of values is 6
! valvib(1) to valvib(nvalvi) is first lat values
			nvalvi=npoints

			valvib(1)= sigz(nat)-ntimes*mulstep
			valvib(npoints)= sigz(nat)+ntimes*mulstep

            do ivalvi = 1,nvalvi
              valvib(ivalvi) = valvib(1)     &
             +(ivalvi-1)					 &
             *(valvib(nvalvi)-valvib(1))	 &
             /(nvalvi-1)
            end do

! naf is number of atoms affecteted

            do i = 1,naf
! get ndis is atoms number affected
			if(delx(i).gt.0.0.or.dely(i).gt.0.0.or.delz(i).gt.0.0) then
                ivib(i) = 1
			end if
            end do


! non-equal option
              do ndis = 1,nat
                if (ivib(ndis) .eq. 1) then
				   v(ndis,1) = (sigz(ndis)-(ntimes*mulstep))
				   v(ndis,2) = (sigz(ndis)+(ntimes*mulstep))
				    else
                  v(ndis, 1) = 0.
                  v(ndis, 2) = 0.
                end if
              end do

          do j = 1,npoints
            matvib(j) = 0
          end do

        nvi = 0

! ncombi total combinations


      i_aid = 1

	  do i_aid=1,npoints
          nvi = nvi+1

          matvib(nvi) = i_aid

          do iat = 1, nat
            vibra(iat+nat*(nvi-1)) = sigx(iat)
          end do
          do ipv = 1, npv
               terpol =   (valvib(i_aid)     &
                      -valvib(1) )		&
                     /(valvib(nvalvi)   &
                      -valvib(1) )
            do iat = 1, nat
              if (ivib(iat) .eq. 1) then
                vibra(iat+nat*(nvi-1)) =    &
                      v(iat, 1)				&
                    +(v(iat, 2)				&
                     -v(iat, 1) )*terpol
              end if
            end do
          end do

	end do
        do iat = 1, nat
          vibmax(iat) = sigx(iat)
          do ivi = 1, nvi
            vibmax(iat) = max (vibmax(iat), vibra(iat+nat*(ivi-1)))
          end do
        end do

        do iat = 1,nat
          if (nvi .gt. 1) then
            do ivi = 2, nvi
              if (vibra(iat+nat*(ivi-1)) .ne. vibra(iat)) nav = iat
            end do
          end if
        end do
		
		End select

	    nst = max(1, nst)
        nvi = max(1, nvi)
        mps = max(1, nps)
        mpv = max(1, npv)
        mas = max(1, nas)
        mav = max(1, nas, nav)



        do iat = 1, mav
          sigx(iat) = sqrt(vibmax(iat)**2 + 0.8*relmax(iat))
          sigy(iat) = sigx(iat)
          sigz(iat) = sigx(iat)
        end do

		deallocate(aver_x,aver_y,aver_z)
		deallocate(natx,naty,natz)
		deallocate(delta_x,delta_y,delta_z)
		deallocate(disx,disy,disz)
		deallocate(v)
		deallocate(ixyz)
		deallocate(istr, ivib)



        return
    end subroutine mmodel

	subroutine alter(p,basefile,infile)
!	Subroutine called to alter a crystal according to 
!     parameters from powell search
  	use sparms
	implicit none
    integer    :: i                              
    real       :: p(nparms)
	real		 :: scth
    character(80) ::  header,basefile,infile
!	
!	read in a sincalc file
!

        open (1, file = basefile, status = 'old' &
            , access = 'sequential'  &
            , form = 'formatted'	  &
            )

        read (1, *)                     header
        read (1, *)                     ndate, numb
        read (1, *)                     (mode(i), i = 1,8)
        read (1, *)                     (arrdim(i), i = 1,19)


		nat					=arrdim(1) 
		nel					=arrdim(2) 
		ngx					=arrdim(3) 
		ngy					=arrdim(4) 
		ngz					=arrdim(5) 
		nx1					=arrdim(6) 
		ny1					=arrdim(7) 
		nz1					=arrdim(8) 
		nan					=arrdim(9) 
	    nat					=arrdim(1)
	    nel					=arrdim(2)
	    ngx					=arrdim(3)
	    ngy					=arrdim(4)
	    ngz					=arrdim(5)
	    nx1					=arrdim(6)
  	    ny1					=arrdim(7)
	    nz1					=arrdim(8)
	    nan					=arrdim(9)
!
!	Allocate the arrays
!
        allocate (x(nat), y(nat), z(nat))
        allocate (ntypat(nat))
        allocate (kx(nat), ky(nat), kz(nat))           
        allocate (sigx(nat), sigy(nat), sigz(nat))       
        allocate (nzt(nel), rmt(nel))        
! add an additional 10 on icase no. of groups changes after
! altering the crystal
        allocate (vx(nx1+10), vy(ny1+10), vz(nz1+10)) 
 
        do iel = 1,nel
          read (1, *)                   nzt(iel), rmt(iel)
        end do
        read (1, *)		               ntypov, cov
        read (1, *)                    cor_cof, cor_dis
        do iat = 1,nat
         read (1, *)			 x(iat),y(iat),z(iat)			&
								,kx(iat),ky(iat),kz(iat)		&
								,sigx(iat),sigy(iat),sigz(iat)  &
								,ntypat(iat)
        end do 
        read (1, *)                     xper, yper
		read (1, *) 			        (vx(i),i=1,ngx)
        read (1, *)                     (vy(i),i=1,ngy)
        read (1, *)                     (vz(i),i=1,ngz)
        read (1, *)                     phi,chthet,scth,step,factor
        read (1, *)                     nzi,rmi,energy, fluxc,fluxb
!
!	readin multicalc info for gradient calcs in dfp method
!        
      close (1)
 	  call  altercrs(p)

!	write sincalc file to input name    
	arrdim(3)=ngx
	arrdim(4)=ngy
	arrdim(5)=ngz
	arrdim(6)=ngx+1
	arrdim(7)=ngy+1
	arrdim(8)=ngz+1
	if(gradopt .eq. 3) mode(7) = 1

	open(unit=1,file=infile,status='unknown')

        write (1,'(1X,A)')              header
        write (1,'(1X,2I4)')            ndate, numb
        write (1,'(1X,8I2)')            (mode(i), i = 1,8)
        write (1,'(1X,19I4)')           (arrdim(i), i = 1,19)

        do i = 1,arrdim(2)
          write (1,'(1X,I4,F8.3)')      nzt(i), rmt(i)
        end do

        write (1,'(1X,I4,F8.3)')                   ntypov, cov
        write (1,'(1X,2F8.3)')                     cor_cof, cor_dis



        do i = 1,nat
          write (1,'(1X,3F8.3,3I4,3F8.3,I4)')     &
          &			     x(i),y(i),z(i), kx(i),ky(i),kz(i) &
          &                          ,sigx(i),sigy(i),sigz(i), ntypat(i)
        end do

        write (1,'(1X,2F8.3)')          xper, yper
        write (1,'(1X,8F8.3)')          (vx(i), i = 1,ngx)
        write (1,'(1X,8F8.3)')          (vy(i), i = 1,ngy)
        write (1,'(1X,8F8.3)')          (vz(i), i = 1,ngz)
        write (1,'(1X,6F8.3)')          phi,chthet,scth,step,factor
        write (1,'(1X,I4,2F9.3,1X,E9.3,1X,E9.3)')    &
        			&       nzi,rmi,energy, fluxc,fluxb

        close (1)
	
        deallocate (x,y, z)
        deallocate (ntypat)
        deallocate (kx, ky,kz)           
        deallocate (sigx, sigy,sigz)       
        deallocate (nzt, rmt)        
        deallocate (vx, vy, vz) 

	end	subroutine alter





	subroutine altercrs(p)
!
!	alters the crystal according to the
!
	use sparms 
	use rfactor
	implicit none
	integer ::     i,j
	real	::     p(nparms)


	do i=1,nparms
 	  do j=1,naff(i)
 	   if (abs(dx(i,j)).gt.0.0) then
 	    x(j)=x(j)+(p(i)*dx(i,j))
 	   end if

 	   if (abs(dy(i,j)).gt.0.0) then
 	    y(j)=y(j)+(p(i)*dy(i,j))
 	   end if

 	   if (abs(dz(i,j)).gt.0.0) then
 	    z(j)=z(j)+(p(i)*dz(i,j))
 	   end if

 	   if (dsx(i,j).gt.0.0) then
 	    sigx(j)=(p(i)*dsx(i,j))
 	   end if

 	   if (dsy(i,j).gt.0.0) then
  	    sigy(j)=(p(i)*dsy(i,j))
 	   end if

 	   if (dsz(i,j).gt.0.0) then
	    sigz(j)=(p(i)*dsz(i,j))
	   end if

	  end do  

	end do
	call group(nat,x,ngx,kx,vx)
	call group(nat,y,ngy,ky,vy)
	call group(nat,z,ngz,kz,vz)
	return	
	end subroutine altercrs
	



	subroutine altermulti(p,parmno,basefile,infile)
!   
!	Subroutine called to alter a crystal according to 
!
	use sparms
	  implicit none
	  real,dimension(:),allocatable :: ix,iy,iz
      integer    :: i,parmno,ist,ivi,modout,option
      real       :: p(nparms),scth
      character(80) ::  header,basefile,infile
!	
!	read in a sincalc file
!
	modout=1
        open (1, file = basefile, status = 'old' &
            , access = 'sequential'  &
            , form = 'formatted'	  &
            )

        read (1, *)                     header
        read (1, *)                     ndate, numb
        read (1, *)                     (mode(i), i = 1,8)
        read (1, *)                     (arrdim(i), i = 1,19)


		nat					=arrdim(1) 
		nel					=arrdim(2) 
		ngx					=arrdim(3) 
		ngy					=arrdim(4) 
		ngz					=arrdim(5) 
		nx1					=arrdim(6) 
		ny1					=arrdim(7) 
		nz1					=arrdim(8) 
		nan					=arrdim(9) 
	    nat					=arrdim(1)
	    nel					=arrdim(2)
	    ngx					=arrdim(3)
	    ngy					=arrdim(4)
	    ngz					=arrdim(5)
	    nx1					=arrdim(6)
  	    ny1					=arrdim(7)
	    nz1					=arrdim(8)
	    nan					=arrdim(9)
!
!	Allocate the arrays
!
        allocate (x(nat), y(nat), z(nat))
        allocate (ix(nat), iy(nat), iz(nat))
        allocate (ntypat(nat))
        allocate (kx(nat), ky(nat), kz(nat))           
        allocate (sigx(nat), sigy(nat), sigz(nat))       
        allocate (nzt(nel), rmt(nel))        
        allocate (vx(nx1+10), vy(ny1+10), vz(nz1+10)) 
		 
        do iel = 1,nel
          read (1, *)                   nzt(iel), rmt(iel)
        end do
        read (1, *)				        ntypov, cov
        read (1, *)                     cor_cof, cor_dis
        do iat = 1,nat
         read (1, *)            x(iat),y(iat),z(iat)       &
                            , kx(iat),ky(iat),kz(iat)      &
                           ,sigx(iat),sigy(iat),sigz(iat)  &
                        , ntypat(iat)
        end do 
        read (1, *)                     xper, yper
		read (1, *)   		            (vx(i),i=1,ngx)
        read (1, *)                     (vy(i),i=1,ngy)
        read (1, *)                     (vz(i),i=1,ngz)
        read (1, *)                     phi,chthet,scth,step,factor
        read (1, *)                     nzi,rmi,energy, fluxc,fluxb
!	readin multicalc info for gradient calcs in dfp method
!        
        
       close (1)
	write(*,*) 'Readin all'

	call  altercrs(p)

	write(*,*) 'Crystal Altered'
!	write sincalc file to input name    
	arrdim(3)=ngx
	arrdim(4)=ngy
	arrdim(5)=ngz
	arrdim(6)=ngx+1
	arrdim(7)=ngy+1
	arrdim(8)=ngz+1
	write(*,*) 'Crystal Altered'
	option=1
	write(*,*) parmno
	write(*,*) naff(parmno)
	write(*,*) dx(parmno,i)
	do i=1,naff(parmno)
	if(dx(parmno,i).gt.0.0.or.dy(parmno,i).gt.0.0.or.dz(parmno,i).gt.0.0) then
		option=0
	end if
	end do
	write(*,*) 'Crystal Altered'
	if(option.eq.0) then
		ix(1:naff(parmno))=dx(parmno,1:naff(parmno))
		iy(1:naff(parmno))=dy(parmno,1:naff(parmno))
		iz(1:naff(parmno))=dz(parmno,1:naff(parmno))		
	else
		option=1
		ix(1:naff(parmno))=dsx(parmno,1:naff(parmno))
		iy(1:naff(parmno))=dsy(parmno,1:naff(parmno))
		iz(1:naff(parmno))=dsz(parmno,1:naff(parmno))		
	end if
	write(*,*) 'Calling multimodel'
    call mmodel(option,naff(parmno),ix,iy,iz,gstep(parmno)) 
	write(*,*) 'multimodel called'


	mode(8)=1
    arrdim(10) = nst
    arrdim(11) = nvi
    arrdim(12) = nps
    arrdim(13) = npv
    arrdim(14) = nas
    arrdim(15) = nav
    arrdim(16) = mps
    arrdim(17) = mpv
    arrdim(18) = mas
    arrdim(19) = mav

	open(unit=1,file=infile,status='unknown')

        write (1,'(1X,A)')              header
        write (1,'(1X,2I4)')            ndate, numb
        write (1,'(1X,8I2)')            (mode(i), i = 1,8)
        write (1,'(1X,19I4)')           (arrdim(i), i = 1,19)
        do i = 1,arrdim(2)
          write (1,'(1X,I4,F8.3)')      nzt(i), rmt(i)
        end do
        write (1,'(1X,I4,F8.3)')       ntypov, cov
        write (1,'(1X,2F8.3)')          cor_cof, cor_dis



        do i = 1,nat
          write (1,'(1X,3F8.3,3I4,3F8.3,I4)')   &
                            &        x(i),y(i),z(i), kx(i),ky(i),kz(i) &
                                    ,sigx(i),sigy(i),sigz(i), ntypat(i)
        end do
        write (1,'(1X,2F8.3)')          xper, yper
        write (1,'(1X,8F8.3)')          (vx(i), i = 1,ngx)
        write (1,'(1X,8F8.3)')          (vy(i), i = 1,ngy)
        write (1,'(1X,8F8.3)')          (vz(i), i = 1,ngz)
        write (1,'(1X,6F8.3)')          phi,chthet,scth,step,factor
        write (1,'(1X,I4,2F9.3,1X,E9.3,1X,E9.3)')    &
         			&       nzi,rmi,energy, fluxc,fluxb

		write(*,*) 'Outputting multimodel parameters'
!
! multimodel parameters
!
          if (nps .gt. 0) then
              write (1,'(1X,A,I4)')     pnames(parmno), nvalst
              write (1,'(8(1X,E9.3))')  (valstr(i), i = 1,nvalst)
              write (1,'(1X,20I4)')     (matstr(i), i = 1,nst)
          end if
          if (npv .gt. 0) then
              write (1,'(1X,A,I4)')     pnames(parmno), nvalvi
              write (1,'(8(1X,E9.3))')  (valvib(i), i= 1,nvalvi)
              write (1,'(1X,20I4)')     (matvib(i), i= 1,nvi)
          end if
			
          do ist = 1,nst
            write (1,'(1X,3F8.3,2X,3F8.3,2X,3F8.3)')          &
                                     (rel_x(i+(ist-1)*nat)	  &
                                    , rel_y(i+(ist-1)*nat)	  &
                                    , rel_z(i+(ist-1)*nat), i = 1,mas)
          end do
          do ivi = 1,nvi
		      write (1,'(1X,10F8.3)')     (vibra(i+(ivi-1)*nat), i = 1,mav)
          end do
          write (1,'(1X,I4)')           modout

!
! End multimodel output
!
        close (1)
	
        deallocate (x,y, z)
        deallocate (ntypat)
        deallocate (kx, ky,kz)           
        deallocate (sigx, sigy,sigz)       
        deallocate (nzt, rmt)        
        deallocate (vx, vy, vz) 
		deallocate (ix, iy, iz) 





	end	subroutine altermulti



    subroutine rftn(fitted)
!
!   This subroutine checks the rfactor curves
!   to see if convergence has been achived
!   Simply fits a cubic and finds the minimum
!   or the curve. if its within one step
!   of the centre point for all parameters
!   its been fit.
!   Just a backup in case the rftol 
!   is unrealistic which freqeuntly happens
!   in MEIS 

	use sparms
	use rfactor
!   
	real :: rvalues(max_parms,max_parms),xval(max_parms),ftot(max_points)
	real :: xmin(max_parms),sigma(max_parms),poly(4)
	integer :: sum
	logical :: fitted
	fitted = .FALSE.
 	open(unit=iout,file="rfactor.dat",status='old')
	do j=1,npoints
		read(iout,*) (rvalues(j,i),i=1,nparms)
	end do
	close(iout)
	centre=(npoints+1)/2
	do i=1,npoints
		xval(i)=i
	end do
	do i=1,nparms
		ftot(1:npoints) = rvalues(1:npoints,i)
		CALL FITPOLY(ftot,xval,NPOINTS,POLY)
		call errmin(npoints,xval,poly,xmin(i),sigma(i))		
		xmin(i)=xmin(i)-centre
	end do

	sum =0 
	do i=1,nparms
		if(abs(xmin(i)).lt.1) sum=sum+1
	end do
	if(sum.eq.nparms) fitted=.TRUE.
	return
	end subroutine rftn 




	subroutine errmin(nx,angle,poly,xmin,sigma)
!
!   Find the min and error in r-factor
!   from polynomial fitted to r-factor data.
!   min restricted to range of angle
    implicit none
	integer :: nx    
	real :: poly(4),angle(nx)
	real :: xi,h,xmin,rvalue
	real :: minvalue
	real :: curvemin,sigma

	xmin =0.0000
	h    =0.001
	minvalue= 20000.0
        xi= angle(1)
	do while(xi.lt.angle(nx))

		rvalue =(poly(1)			&	
		&		+poly(2)*xi			& 
		&		+(poly(3)*(xi**2))	& 
		&		+(poly(4)*(xi**3))	) 							
		if(rvalue.lt.minvalue) then	
				minvalue = rvalue
				xmin=xi
		end if
	xi=xi+h
	end do
	curvemin= 6*poly(4)*xmin+2.0*poly(3)
	sigma     = sqrt(abs(2.0/(curvemin)))
	return
	end subroutine errmin
