	module multicalc_params 
!	Multicalc Parameters 
	implicit none 
	real,dimension(:,:),allocatable		::	vib2,vibquo 
	real,dimension(:,:,:,:),allocatable	::	blocking 
	real,dimension(:,:,:),allocatable	::	hit_det,hitprob 
	real,dimension(:),allocatable		::	h_max2,d_max2,sc_imp_par 
	integer,dimension(:),allocatable	::	nzt,rnew 
	real,dimension(:),allocatable		::	rmt,vx,vy,vz,scthet
	real,dimension(:,:),allocatable		::	bltyp 
	real,dimension(:),allocatable		::	bltot 
	integer,dimension(:),allocatable    ::	nvs,nvv 
	real,dimension(:,:),allocatable		::	vals,valv 
	integer,dimension(:,:), allocatable ::	matv,mats 
        real,dimension(:,:) ,allocatable    ::	contri, pnsig 
	real,dimension(:,:,:),allocatable  ::	pnvib 
	real,dimension(:),allocatable		::	poutv 
	integer,dimension(:),allocatable	::	i_differ 
	integer,dimension(:),allocatable	::	ntypat 
	integer,dimension(:),allocatable	::	kx,ky,kz 
	real,dimension(:),allocatable		::	x,y,z 
	real,dimension(:,:),allocatable		::	rel_x,rel_y,rel_z 
	real,dimension(:),allocatable		::	sig,sig2 
	real,dimension(:),allocatable		::  x_imp,y_imp,z_imp 
	real,dimension(:,:),allocatable		::  deflection 
    integer, allocatable :: lattice(:,:,:)          
    character, allocatable :: nams(:)*20, namv(:)*20 
    real				   :: gauss(0:2000)           
    real expo(-25000:5000)                     !Faster expon.function 
    integer iroot(0:400000)                  !Sqrt array 
	character text*80, io_name*80,output_file*80       & 
             , status_file*80, hour*24, numb_mul*4, name_mul*80 
	real		:: xper, yper, cov, def_rms, phi, thet, thet2 
	real		:: zmin, zmax, dmax, fake_cs, real_cs, energy 
	real		:: el_loss_fac, rmi, blmax, degrad 
    real		:: d, u, xr, yr, zr 
	real		:: xt, yt, zt 
	real		:: xpr, ypr, zpr 
	real		:: sinphi, cosphi, sinth, costh, tanth 
	real		:: coscos, cossin, sincos, sinsin 
	real		:: tancos, tansin 
	real		:: sico2, sisi2, coth2 
	real		:: e1, e2, isignx, isigny 
	real		:: scrlen,coulomb 
	real		:: pi 
  	integer		:: iat 
	integer		:: ntypov, iatom, ian, nan_f, nproj, npreal, nzi,iran, i_dot 
	integer		:: kxpr, kypr, kzpr 
	integer		:: zi,ztarg 
    integer		:: time                               !PB - need this!!! 
	integer		:: nat,nan,nel,ngx,ngy,ngz,nx1,ny1,nz1 
    integer		:: nst,nvi,nps,npv,nas,nav,mps,mpv,mas,mav 
	integer		:: mode(8)                            !Run mode (see VEGAS) 
    integer		:: arrdim(19)                         !Array dimensions 
    integer     :: lx(2), ly(2), lz(2) 
	real		:: x_shift(2), y_shift(2) 
	end module multicalc_params 
 
 
	module multicalc_code 
!	Multicalc code partially converted to f90 
!   still needs some work. 
!	reduced output to angles and yield only 
!   for use in bfgs code 
!   but...it works as it is 
	implicit none 
	private 
	public multicalc 
	contains 
      subroutine multicalc(input_name,output_name) 
	  use multicalc_params 
	  implicit none	 
	  real			:: ln33e3,cum_1,cum_2,total 
	  real			:: prefac,x1,x2,dummy1,dummy2 
	  real			:: chthet,step,fluxc,fluxb 
	  real			:: zmax1,sum,relmax,vibmax,relat 
	  real			:: vibat,chphi,scthetc,e_old,trajec,scetmin 
	  real			:: flux,scm_old,rmit,factor	 
	  integer		:: ig,ix,i,ndate,numb,iel,igx,igy,igz 
	  integer		:: ips,iva,ist,ipv,ivi,modout,ntype,nprojtot 
	  integer		:: new,nto,ibd 
	  integer		:: iofailed 
      parameter (ln33e3 = 10.4) 
 
 	  character(80) input_name,output_name 
!--------------------------------------- START -----------------------------------*
 
!Its name is the name of the output_file with the extension 'status'        
	  status_file = output_name 
	  i_dot = max(1, index(status_file, ']'))
	  do while (i_dot .le. 50							&
	        .and. status_file(i_dot:i_dot) .ne. ' '		&
	        .and. status_file(i_dot:i_dot) .ne. '.')	
	     i_dot = i_dot+1                       
	  end do
	  status_file(i_dot:57) = '.status'


        pi = 4.*atan(1.)                                !Calculation of pi
        degrad = pi/180.                                !Degrees -> radians
 
!	call gaussian
        cum_1 = 0.                                      !Production of the array 
        cum_2 = 0.                                      ! 'GAUSS', which is the 
        total = 5.e-4                                   ! inverse of the 
        ig = 1001                                       ! cumulative gauss 
        ix = 0                                          ! distribution 
        prefac = 1.e-4/sqrt(8.*atan(1.)) 
10      ix = ix+1 
        x1 = (ix-0.5)*1.e-4 
        x2 = ix*1.e-4 
        cum_2 = cum_1+prefac*exp(-0.5*(x1**2)) 
20      if (cum_2 .lt. total) then 
          cum_1 = cum_2 
          goto 10 
        else 
          gauss(ig) = x2-(1.e-4)*(cum_2-total)  & 
                             /(cum_2-cum_1) 
          ig = ig+1 
          total = (ig-1000)*5.e-4 
          if (ig .eq. 2000) total = total-5.e-5 
          if (ig .eq. 2001) goto 25 
          goto 20 
        end if 
25      do ig = 0, 999 
          gauss(ig) = -gauss(2000-ig) 
        end do 
        gauss(1001) = 0. 
 

        do i= -25000,-1                                 !Speeds up the
          expo(i) = exp((i-0.5)/125.)                   ! calculation of
        end do                                          ! exponents by a factor
        expo(0) = 1.                                    ! five
 
        do i = 1,5000
          expo(i) = exp((i+0.5)/125.)
        end do

        do i = 0,400000                                 !Speeds up function SQRT
          iroot(i) = nint(sqrt(i+0.5))                  ! by a factor six
        end do
 
!-------------------------------- INPUT ---------------------------------------*
        open (1, file=input_name, status='old', access='sequential'    & 
	         , form = 'formatted', iostat = iofailed)

        read (1, '(A)')                 text 
        read (1, *)                     ndate, numb
        read (1, *)                     (mode(i), i = 1,8)
        if   (mode(4) .ne. 0											&
             .or. mode(5) .ne. 0										&
             .or. mode(6) .ne. 0										&
             .or. mode(7) .ne. 0										&
             .or. mode(8) .ne. 1) then
          close (1)
	stop
        end if
        read (1, *)                     (arrdim(i), i = 1,19)
	nat=arrdim(1) 
	nel=arrdim(2) 
	ngx=arrdim(3) 
	ngy=arrdim(4) 
	ngz=arrdim(5) 
	nx1=arrdim(6) 
	ny1=arrdim(7) 
	nz1=arrdim(8) 
	nan=arrdim(9) 
	nst=arrdim(10) 
	nvi=arrdim(11) 
	nps=arrdim(12) 
    npv=arrdim(13) 
    nas=arrdim(14) 
    nav=arrdim(15) 
    mps=arrdim(16) 
    mpv=arrdim(17) 
    mas=arrdim(18) 
    mav=arrdim(19) 
 
! =================================================================== 
! Allocating Arrays 
! =================================================================== 
	allocate (x_imp(nel), y_imp(nel), z_imp(nel)) 
	allocate (contri(nvi,nst)) 
	allocate (pnsig(650, mav), pnvib(650, nvi, mav)) 
	allocate (poutv(nvi)) 
	allocate (deflection(nel, 0:10000)) 
	allocate (nvs(mps))                            !# values of str. param. 
    allocate (nvv(mpv))                            !# values of vib. param. 
    allocate (vals(mps,nst))                       !Values of str.parameter 
    allocate (valv(mpv,nvi))                       !Values of vib.parameter 
    allocate (mats(mps,nst))                       !Value nr. for given str 
    allocate (matv(mpv,nvi))                       !Value nr. for given vib 
    allocate (x(nat), y(nat), z(nat))              !Atom coordinates 
    allocate (ntypat(nat))                         !Atom type 
    allocate (i_differ(nat))                       !Type str./vib. differen 
    allocate (kx(nat), ky(nat), kz(nat))           !Group numbers of atoms 
    allocate (rel_x(nst,mas))                      !Relative x, y and z- 
    allocate (rel_y(nst,mas))                      !   coordinates for each 
    allocate (rel_z(nst,mas))                      !   structure model 
    allocate (sig(nat), sig2(nat))                 !Vibration amplitudes 
    allocate (vib2(nvi,mav), vibquo(nvi,mav))      !   and related arrays 
    allocate (hit_det(nvi, nst, nat))              !Hitting/detection prob. 
    allocate (hitprob(nvi, nst, nat))              !Hitting probability 
    allocate (blocking(nvi, nst, nat, nan))        !Blocking profiles 
    allocate (h_max2(nat))                         !see below 
    allocate (d_max2(nel))                         !see below 
    allocate (sc_imp_par(nel))                     !Impact par. for backsc. 
    allocate (nzt(nel))
    allocate (rmt(nel))                  !Target at.nr. and mass 
    allocate (vx(nx1), vy(ny1), vz(nz1))           !X-, Y- and Z-planes 
    allocate (scthet(nan))                         !Scattering angles 
    allocate (bltyp(nel, nan))                     !Profile for elements 
	allocate (lattice(ngx, ngy, ngz))              !Aux. lattice 
	allocate (nams(mps), namv(mpv))                !Multiparameter output file 
        do iel = 1,nel
          read (1, *)                   nzt(iel), rmt(iel)
        end do
        read (1, *)                     ntypov, cov
        read (1, *)                     dummy1, dummy2 
        do iatom = 1,nat
          i_differ(iatom) = 1
          read (1, *)                   x(iatom),y(iatom),z(iatom)   &
                                  , kx(iatom),ky(iatom),kz(iatom)	 &
                                  , sig(iatom),dummy1, dummy2		 &
                                  , ntypat(iatom)
        end do 
        read (1, *)                     xper, yper
        read (1, *)                     (vx(igx), igx = 1,ngx)
        read (1, *)                     (vy(igy), igy = 1,ngy)
        read (1, *)                     (vz(igz), igz = 1,ngz) 
        read (1, *)                     phi,chthet,scthet(1),step,factor 
        read (1, *)                     nzi,rmi,energy, fluxc,fluxb 

!       ....................multimodel parameters..................
        if (nps .gt. 0) then
          do ips = 1,nps
            read (1,*)			nams(ips), nvs(ips) 
            read (1, *)                 (vals(ips, iva)				&
                                      , iva = 1,nvs(ips))
            read (1, *)                 (mats(ips, ist), ist = 1,nst)
          end do
        end if
        if (npv .gt. 0) then
          do ipv = 1,npv
            read (1,*)        namv(ipv), nvv(ipv)
            read (1, *)                 (valv(ipv, iva)				&	
                                     , iva = 1,nvv(ipv))
            read (1, *)                 (matv(ipv, ivi), ivi = 1,nvi)
          end do
        end if
        do ist = 1,nst
          read (1, *)                   (rel_x(ist, iatom)			&
		                              , rel_y(ist, iatom)			&
                                     , rel_z(ist, iatom), iatom = 1,mas)
        end do
        do ivi = 1,nvi
          read (1, *)                   (vib2(ivi, i), i = 1,mav)
        end do
        read (1, *)                     modout

        close (1)
 
! Finished Reading in parameters 
	CALL RANDOM_SEED (SIZE = I)  ! I is set to the size of 
                    ! the seed array
		ALLOCATE (rnew(I))
		rnew = 100
		CALL RANDOM_SEED (PUT=rnew(1:I)) ! Sets seed from array
		deallocate(rnew)
        lattice = 0                                     !Blanking aux. lattice

        if (mode(2) .eq. 1) then                        !Number of elements
          ntype = nel-1                                 ! in the crystalline
          do iatom = 1,nat                                ! part of the substrate,
            if (ntypat(iatom) .eq. ntypov) ntype = nel    ! not including the
          end do                                        ! amorphous overlayer.
        else
          ntype = nel
        end if

        zmin = 0.
        zmax1 = 0.

        do ist = 1,nst
          do iatom = 1,mas
            sum = z(iatom)+rel_z(ist, iatom)
            zmin = min(zmin, sum)                       !Minimum z-coordinate.
            zmax1 = max(zmax1, sum)                     !Maximum z-coordinate.
            if (rel_z(ist, iatom) .ne. 0.)							&
					  i_differ(iatom) = 3
            if ((rel_x(ist, iatom) .ne. 0.) .or. (rel_y(ist, iatom) .ne. 0.)) i_differ(iatom) = 5
		  end do
        end do

        do ivi = 1,nvi
          do iatom = 1,mav
            if (vib2(ivi, iatom) .ne. vib2(1, iatom)				&
         .and. (i_differ(iatom) .eq. 1 .or.							&
                i_differ(iatom) .eq. 3 .or.							&
                i_differ(iatom) .eq. 5))							&
           i_differ(iatom) = i_differ(iatom)+1
          end do
        end do
!Min z-coordinate,Max z-coordinate,Filling up aux lattice for calc. hitting probs
        do iatom = 1,nat
          zmin = min (zmin, z(iatom))                     
          zmax1 = max (zmax1, z(iatom))                   
          lattice(kx(iatom), ky(iatom), kz(iatom)) = iatom      
          sig2(iatom) = 125./(2.*sig(iatom)**2)             
        end do
 
!Like sig2, for calc. of hitting probabilities.Ratio vib2/sig2.
        do ivi = 1,nvi
          do iatom = 1,mav
            vib2(ivi, iatom) = 125./(2.*vib2(ivi, iatom)**2)       
            vibquo(ivi, iatom) = vib2(ivi, iatom)/sig2(iatom) 
          end do
        end do

        do iatom = 1,nat
          relmax=0.
          vibmax=0.
          do ist = 1,nst
            if (iatom .le. mas) then
              relat = rel_x(ist, iatom)**2							&
     				 +rel_y(ist, iatom)**2							&
      				 +rel_z(ist, iatom)**2
            else
              relat = 0.
            end if
            relmax = max(relmax, relat)                 !Maximum structural
          end do                                        ! displacement of atom
          do ivi = 1,nvi                                ! iatom from its average
            if (iatom .le. mav) then                      ! position.
              vibat = 1./vib2(ivi, iatom)
            else
              vibat = 1./sig2(iatom)
            end if
            vibmax = max(vibmax, vibat)                 !Maximum vibration
          end do                                        ! amplitude of atom iatom.
          vibmax = vibmax*125.
!Minimum sq. impact par. for contribution to hit./det. probs. 
          h_max2(iatom) = (sqrt(relmax)+sqrt(vibmax*ln33e3))**2            
        end do                                

!The first x,y planes are repeated 
        vx(nx1) = xper                 
        vy(ny1) = yper                                  
!Conversion degrees -> radians
        phi				= phi*degrad                                
        chthet			= chthet*degrad                          
        scthet(1)		= scthet(1)*degrad
        step			= step*degrad
        do ian = 1,nan
          scthet(ian)	= scthet(1)+(ian-1)*step 
        end do

        nan_f = 0

!--------------------------------- SHADOWING ----------------------------------*
	    hit_det = 0.                                    !Set hitt.probs. to zero
        if (mode(2) .eq. 1) then                        !Set rms. defl. angle in
          def_rms = 0.                                  ! overlayer to zero
        end if
        ian		= 0                                         !Scatt. angle nr. 'zero'
        chphi	= phi                                     !Azimuthal angle of beam
        thet	= chthet                                   !Polar angle of beam
        scthetc = (scthet(1)+scthet(nan))*0.5           !Average scatt. angle
        thet2	= thet+scthetc                            !Corresp. polar angle
        nproj	= fluxc*xper*yper*cos(thet)               !Number of ch. ions

        el_loss_fac = 1.                                !Energy=primary energy
        e_old		= 1.

        call potent                                     !Calc. deflection table
        call scat_imp (scthetc, sc_imp_par)              


        trajec	= zmax1/cos(thet)                        !Aver. trajectory length
        scetmin = 0.1/trajec                            !Minimum deflection
        scetmin = min (scetmin, 0.1*degrad)             ! angle which is to be
        scetmin = max (scetmin, 0.01*degrad)            ! properly treated
        scm_old = scetmin
        call scat_imp (scetmin, d_max2)              
        do iel = 1,nel
          dmax = max(dmax, d_max2(iel))
          d_max2(iel) = 1./(d_max2(iel)**2)
        end do
        zmax	= zmax1+dmax                               !Calculation depth
        vz(nz1) = zmax
 
        call exclusion                                  !Probs. for no collision
 	    call fdate (hour) 
        call track(*50)                                 !Actual calculation
 
 
        flux = npreal/(xper*yper*cos(thet))             !Real flux
        nprojtot = npreal 
 
!hitting probabilities are normalized
	  do iatom = 1,mav
	    do ist = 1,nst
	      do ivi = 1,nvi
              hitprob(ivi, ist, iatom) =                    &
                    hit_det(ivi, ist, iatom)             	&
                    *vib2(ivi, iatom)						&
                    /(125.*pi*fake_cs*flux)
              hit_det(ivi, ist, iatom) = 0.
            end do
          end do
        end do
        if (mav .lt. nat) then
          do iatom = mav+1,nat
            do ist = 1,nst
              do ivi = 1,nvi
                hitprob(ivi, ist, iatom) =					&
                     hit_det(ivi, ist, iatom)				&
                     *sig2(iatom)							&
                     /(125.*pi*fake_cs*flux)				
                hit_det(ivi, ist, iatom) = 0.
              end do
            end do
          end do
        end if

!----------------------------------- BLOCKING ---------------------------------*
!Azimuth changed by pi  
!Polar angle of beam 
!Ion mass + target mass 
        phi		= phi+pi                                    
        thet2	= pi-chthet                               
        rmit	= rmi+rmt(ntypat(nat))                     
!Loop over det. angles
        do ian = 1, nan                                  
!Polar angle of detector
          thet = thet2-scthet(ian)                       
!Number of bl. ions
          nproj = fluxb*xper*yper*cos(thet)              
!Elastic energy loss factor
          el_loss_fac = (rmi*cos(scthet(ian))/rmit      &
       +sqrt((rmi*cos(scthet(ian))/rmit)**2.           	&
       +(rmt(ntypat(nat))-rmi)/rmit))**2.               
          if (abs(el_loss_fac-e_old) .gt. 0.02) then 
!New deflection angles
            call potent                                 
            e_old = el_loss_fac
            new = 1
          else
            new = 0
          end if
          call scat_imp (scthet(ian), sc_imp_par)              
          trajec = zmax1/cos(thet)
          scetmin = 0.1/trajec                          !See shadowing part
          scetmin = min (scetmin, 0.1*degrad)           ! for comments.
          scetmin = max (scetmin, 0.01*degrad)
          if (abs(scetmin-scm_old) .gt. 0.01*degrad.or. new .eq. 1) then
			call scat_imp (scetmin, d_max2)            
            do iel = 1,nel
              dmax = max(dmax, d_max2(iel))
              d_max2(iel) = 1./(d_max2(iel)**2)
            end do
            scm_old = scetmin
            zmax = zmax1+dmax
            vz(nz1) = zmax
            call exclusion                              !Probs. for no collision
          end if

          call track(*40)                               !Actual calculation

          flux = npreal/(xper*yper*cos(thet))
          nprojtot = nprojtot+npreal
          do iatom = 1,mav
            do ist = 1,nst
              do ivi = 1,nvi 
 !Backscattering signal
                blocking(ivi, ist, iatom, ian) =		 &	
! = hitting probability 
                     hitprob(ivi, ist, iatom)            &  
! * detect. probability
                     *hit_det(ivi, ist, iatom)           & 
                     *vib2(ivi, iatom)					 &
                     /(125.*pi*fake_cs*flux)
                hit_det(ivi, ist, iatom) = 0.
              end do
            end do
          end do
          if (mav .lt. nat) then
            do iatom = mav+1,nat
              do ist = 1,nst
                do ivi = 1,nvi
                  blocking(ivi, ist, iatom, ian) =		&
                     hitprob(ivi, ist, iatom)			&
                     *hit_det(ivi, ist, iatom)			&
                     *sig2(iatom)						&
                     /(125.*pi*fake_cs*flux)
                  hit_det(ivi, ist, iatom) = 0.
                end do
              end do
            end do
          end if

          nan_f = ian                                   !Nr. of finished angles

        end do                                          !End loop det. angles

!------------------------------------- OUTPUT ---------------------------------*
40      if (nan_f .eq. 0) goto 50                       !First angle not ready

          nto = 0
          do ist = 1,nst
            do ivi = 1,nvi

              nto = nto + 1                            !PB - 
              write (numb_mul,'(I4)') nto    !converts multiparameter counter to string 'numb_mul'
              if (nto .lt. 10) then
                 numb_mul(1:3) = '000'
              end if
 
              if (nto .ge. 10 .and. nto .lt. 100) then
                 numb_mul(1:2) = '00'
              end if 
 
              if (nto .ge. 100 .and. nto .lt. 1000) then 
                 numb_mul(1:1) = '0' 
              end if 

 
!name_mul is the multimodel output file name 
              name_mul = output_name                   
 
              do while (i_dot .le. 50						&
                 .and. name_mul(i_dot:i_dot) .ne. ' '		&
                 .and. name_mul(i_dot:i_dot) .ne. '.')
                 i_dot = i_dot+1
              end do
!adds multiparameter number to filename creates file
              name_mul(i_dot:57) = '.'//numb_mul           
              open  (1, file = name_mul, status = 'unknown'    &
                   , access = 'sequential'		       &
                   , form = 'formatted', iostat = iofailed)
                    inquire (1, name = output_file)
              if (iofailed .ne. 0) then
                open  (1, file = 'dump.out', status = 'new'	 & 	
                       , access = 'sequential'		         &
                       , form = 'formatted')
                inquire (1, name = output_file)
	        end if
 
              ibd = 0
              do ian = 1,nan_f                          !Loop over angles
                do iel = 1, nel
                  bltyp(iel, ian) = 0.
                end do
                do iatom = 1, nat                              !PB -
                    if (blocking(ivi, ist, iatom, ian) .gt. 9.999) then
                        blocking(ivi, ist, iatom, ian) = 9.999
                        ibd = ibd + 1                  !counter for values greater than 10
                    end if
                    bltyp(ntypat(iatom), ian) = &
                    bltyp(ntypat(iatom), ian)	&
                    +blocking(ivi, ist, iatom, ian)
                end do
                do iel = 1, nel
                  bltyp(iel, ian) = bltyp(iel, ian)/factor
                end do

		  write(1,'(1X,F7.2,1X,6F7.3)') scthet(ian)/degrad, (bltyp(i,ian), i=1,nel) 
 
              end do
 	    close(1)
            end do                                      !End loop over strucs.
          end do                                        !End loop over vibs.
  

50        continue

!----------------------------------- STOP -------------------------------------* 
! Cleanup and deallocate
	deallocate (x_imp,y_imp,z_imp) 
	deallocate (contri) 
	deallocate (pnsig,pnvib) 
	deallocate (poutv) 
	deallocate (deflection) 
	deallocate (nvs)              
    deallocate (nvv)              
    deallocate (vals)             
	deallocate (valv)        
	deallocate (mats)        
    deallocate (matv)       
    deallocate (x,y,z)       
    deallocate (ntypat)      
    deallocate (i_differ)    
    deallocate (kx,ky,kz)    
    deallocate (rel_x)       
    deallocate (rel_y)       
    deallocate (rel_z)       
    deallocate (sig,sig2)    
    deallocate (vib2,vibquo) 
    deallocate (hit_det)     
    deallocate (hitprob)     
    deallocate (blocking)    
    deallocate (h_max2)      
    deallocate (d_max2)      
    deallocate (sc_imp_par)  
    deallocate (nzt)
    deallocate (rmt)   
    deallocate (vx,vy,vz)  
    deallocate (scthet)    
    deallocate (bltyp)     
	deallocate (lattice)   
	deallocate (nams, namv)                 
 

300     format  (//,' ************************************************'		&
             ,/, ' **** You''ve made at least one serious error ****'		&
             ,/, ' *********** Sorry I cannot help more ***********')

        end subroutine multicalc 

        SUBROUTINE TRACK(*)
!*******************************************************************************
!       TTTTTT  RRRRR    AAAA    CCCC   K    K                                 *
!         TT    R    R  A    A  C    C  K  KK                                  *
!         TT    RRRRR   AAAAAA  C       KKK                                    *
!         TT    R  R    A    A  C    C  K  KK                                  *
!         TT    R   RR  A    A   CCCC   K    K                                 *
!*******************************************************************************
 
		use multicalc_params	 
		implicit none 
		real    :: a,b,tanphi,cotphi,spread,ystart,xstart,zstart 
		real    :: delx,dely,gonio,sgonio,delta,e11,e21 
		real    :: z_i1,y_i1,x_i1,sinan,cosan,tasi1 
		real    :: taco1,sisi1,sico1,cosi1,coco1 
		real    :: tath1,sith1,sith2,coth1,coph1,siph1,random 
		real    :: over,oversize,sico3,sisi3,coth3,v 
		real    :: t,tan_def,dur,dvr,cosdef 
		integer :: nover,new_dir,iover,ivi,ist,iel 
		integer :: ix,iy,kxstrt,kystrt,numx,numy,isy1,isx1 
 
!--------------------------- GENERAL INITIALIZATION ---------------------------*
        siph1 = sin(phi)                        !phi = initial azimuthal angle
        coph1 = cos(phi)
        sith1 = sin(thet)                       !thet = initial polar angle
        coth1 = cos(thet)
        sith2 = sin(thet2)                      !thet2 = polar angle after
        coth2 = cos(thet2)                      ! backscattering
        tath1 = sith1/coth1
        coco1 = coth1*coph1
        cosi1 = coth1*siph1
        sico1 = sith1*coph1
        sisi1 = sith1*siph1
        sico2 = sith2*coph1
        sisi2 = sith2*siph1
        taco1 = tath1*coph1
        tasi1 = tath1*siph1 
        isx1  = int(sign(1., coph1))            !Moving in pos/neg x-direction
        isy1  = int(sign(1., siph1))            !Moving in pos/neg y-direction
        cosan = sith1*sith2+coth1*coth2         !Cosine of initial scatt. angle
        sinan = sqrt(1.-cosan**2)               !Sine of initial scatt. angle
        x_i1 = (sico2-cosan*sico1)/sinan       !Unit vector in the direction of
        y_i1 = (sisi2-cosan*sisi1)/sinan       ! the (initial) impact parameter
        z_i1 = (coth2-cosan*coth1)/sinan       ! for backscattering
        fake_cs = 1./((cosan-1.)**2)            !CS = (sine(scatt.ang./2.))**-4
        x_shift(1) = 0.
        y_shift(1) = 0.
        e11 = abs(taco1)                        !X-comp/Z-comp of initial veloc.
        e21 = abs(tasi1)                        !Y-comp/Z-comp of initial veloc.

        if (e11 .gt. 1. .or. e21 .gt. 1.) then  !Initial z-coord. of track for
          zstart = zmin-dmax/sith1              ! start in x- or y-direction
        else                                    ! and for
          zstart = 0.                           ! start in z-direction
        end if 
 
!       Projection of amorphous overlayer perpendicular to the beam. The full
!       overlayer is divided into 'nover' layers with a density of approximately
!       1 atom per 2.5x2.5 sq.Angstrom, such that the total number of atoms per
!       cm**2 encountered by the ions corresponds to the required coverage
!       density 'cov':
        if (mode(2) .eq. 1) then
          over = cov*1.e-16/coth1               !Nr. of atoms/A**2 perp. to beam
          nover = 1+int(over*6.25)              !Nr. of layers
          oversize = sqrt(float(nover)/over)    !'Unit cell' size in the layers 
	   end if
!------------------------------ START MAIN LOOP -------------------------------*
!The ions are regularly! distributed over the surface! unit cell. To this end the 
! total number of ions is! adjusted a little bit. 
        delta = 1/sqrt(nproj/(xper*yper*coth1)) 
        gonio = coco1*coco1+siph1*siph1         
        sgonio = sqrt(gonio)                    
        numx = max(1, nint(xper*sgonio/delta))  
        numy = max(1, nint(yper*coth1/(delta*sgonio)))
        npreal = numx*numy                      !Resulting no. of ions
        delx = xper/numx                        !Stepsize in x-direction
        dely = yper/numy                        !Stepsize in y-direction

        kxstrt = 2
        if (mode(1) .eq. 0) then
          xstart = -delx/2.                     !Start positions on mesh
        else
          xstart = -delx                        !Start positions random
        end if

        do 105 ix = 0, numx-1                   !Loop over x-coord. of startpos.
        xstart = xstart+delx
        do while (vx(kxstrt) .lt. xstart)
          kxstrt = kxstrt+1
        end do

        kystrt = 2
        if (mode(1) .eq. 0) then
          ystart = -dely/2.
        else
          ystart = -dely
        end if
        do 100 iy = 0, numy-1                   !Loop over y-coord. of startpos.
        ystart = ystart+dely
        do while (vy(kystrt) .lt. ystart)
          kystrt = kystrt+1
        end do

!--------------------------- INITIALIZATION PER TRACK -------------------------*
        xpr = xstart
        ypr = ystart
        if (mode(1) .eq. 1) then 
		  call random_number(random)	
          xpr = xpr+(random*delx) 
		  call random_number(random)	
          ypr = ypr+(random*dely)
          if (xpr .gt. xper) xpr = xpr-xper     !This might occur due to
          if (ypr .gt. yper) ypr = ypr-yper     ! rounding errors.
        end if
        zpr = zstart
        kxpr = kxstrt
        kypr = kystrt
        kzpr = 1

!       The width of the beam spot, 0.5mm/90mm, as well as the width of the
!       entrance slit, 1.0mm/90mm, are accounted for in the calculation of
!       detection probabilities:
        if (ian .ne. 0) then 
!Out of plane angle of detection 
		  call random_number(random) 
          spread = (random-0.5)*.005555555 
		  call random_number(random)		  	 
		  spread =  spread+(random-0.5)*.01111111
          a = sico1-spread*siph1
          b = sisi1+spread*coph1
          call direction (a, b, coth1)
          new_dir = 1
        else
          cosphi = coph1
          sinphi = siph1
          costh  = coth1
          sinth  = sith1
          coscos = coco1
          cossin = cosi1
          sincos = sico1
          sinsin = sisi1
          new_dir = 0
        end if

        if (mode(2) .eq. 1) then                !Deflection in amorph overlayer
          sico3 = sincos
          sisi3 = sinsin
          coth3 = costh
          do iover = 1,nover 
			call random_number(random)
            u = oversize*(random-0.5)        !Relative coordinates of ion 
			call random_number(random)
            v = oversize*(random-0.5)        ! with respect to overlayer atom
            t = sqrt(u*u+v*v)                   !Impact parameter
!Deflection contribution in layer nover 
            tan_def = deflection(ntypov, nint(2000.*t))          
!Total deflection in u-direction
            dur = tan_def*u/t    
!Total deflection in v-direction
            dvr = tan_def*v/t                   
!Stop in case of backscattering			 
            if (costh-dur*sinth .le. 0.)    goto 100 
!Compute new direction 
            a = sincos+dur*coscos-dvr*sinphi    
            b = sinsin+dur*cossin+dvr*cosphi
            call direction (a, b, costh)
          end do 
!Cosine of deflection angle in overlayer
          cosdef = sincos*sico3+sinsin*sisi3+costh*coth3                 
!Avoiding rounding errors 
          cosdef = min(1., cosdef)           
!Total squared deflection angle
          def_rms = def_rms+(acos(cosdef))**2   
          new_dir = 1
        end if

        real_cs = fake_cs                       !Initialization of the weight
        do ivi = 1,nvi                          ! factors for each of the
          do ist = 1,nst                        ! structure/vibration models
            contri(ivi, ist) = real_cs
          end do
        end do

        if (new_dir .eq. 1) then                !If necessary calculate new
          call new_gonio                        ! goniometry of track
        else
          tanth  = tath1                        !Otherwise use initial
          tancos = taco1                        ! goniometry
          tansin = tasi1
          isignx = isx1
          isigny = isy1
          do iel = 1, nel
            x_imp(iel) = x_i1*sc_imp_par(iel)
            y_imp(iel) = y_i1*sc_imp_par(iel)
            z_imp(iel) = z_i1*sc_imp_par(iel)
          end do
          e1 = e11
          e2 = e21
        end if

        if (e1 .gt. e2 .and. e1 .gt. 1.) then
          tanphi = sinphi/cosphi
          if (mode(1) .eq. 1) call seek_plane(vx, nx1, xpr, kxpr)
          goto 80
        else if (e2 .ge. e1 .and. e2 .gt. 1.) then
          cotphi = cosphi/sinphi
          if (mode(1) .eq. 1) call seek_plane(vy, ny1, ypr, kypr)
          goto 50
        else
          if (mode(1) .eq. 1) then
            call seek_plane (vx, nx1, xpr, kxpr)
            call seek_plane (vy, ny1, ypr, kypr)
          end if
          goto 20
        end if

!---------------------------- EXTRAPOLATION OF TRACK --------------------------*

!--------------------------------- Z-DIRECTION --------------------------------*
10      if (kzpr .eq. ngz) goto 100
        kzpr = kzpr+1                                   !Step to next z-plane
        xpr = xpr+(vz(kzpr)-zpr)*tancos
        ypr = ypr+(vz(kzpr)-zpr)*tansin
        zpr = vz(kzpr)

        call period_bound (xpr, xper)                   !Periodic boundary
        call period_bound (ypr, yper)                   ! conditions xpr,ypr

        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        call seek_plane (vy, ny1, ypr, kypr)            ! kxpr,kypr

!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 10:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
20      lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        lz(1) = kzpr
        call impact (2, 2, 1, *10, *90, *100)

!--------------------------------- Y-DIRECTION --------------------------------*
30      cotphi = cosphi/sinphi

40      kypr = kypr+isigny                              !Step to next y-plane
50      if (kypr .eq. 0) then
          kypr = ngy
          ypr = ypr+yper
        else if (kypr .eq. ny1) then
          kypr = 1
          ypr = ypr-yper
        end if
        xpr = xpr+(vy(kypr)-ypr)*cotphi
        zpr = zpr+(vy(kypr)-ypr)/tansin
        ypr = vy(kypr)
        if (zpr .gt. zmax) goto 100

        call period_bound (xpr, xper)                   !Periodic boundary cond

        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kxpr,kzpr
          kzpr = kzpr+1
        end do

!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 40:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (2, 1, 1, *40, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (2, 1, 1, *40, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (2, 1, 2, *40, *90, *100)
        end if

!----------------------------------- X-DIRECTION ------------------------------*
60      tanphi = sinphi/cosphi

70      kxpr = kxpr+isignx                              !Step to next x-plane
80      if (kxpr .eq. 0) then
          kxpr = ngx
          xpr = xpr+xper
        else if (kxpr .eq. nx1) then
          kxpr = 1
          xpr = xpr-xper
        end if
        ypr = ypr+(vx(kxpr)-xpr)*tanphi
        zpr = zpr+(vx(kxpr)-xpr)/tancos
        xpr = vx(kxpr)
        if (zpr .gt. zmax) goto 100

        call period_bound (ypr, yper)                   !Periodic boundary cond

        call seek_plane (vy, ny1, ypr, kypr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kypr,kzpr
          kzpr = kzpr+1
        end do

!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 70:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (1, 2, 1, *70, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (1, 2, 1, *70, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (1, 2, 2, *70, *90, *100)
        end if

!---------------------------- AFTER A COLLISION ------------------------------*
90      if (e1 .gt. e2 .and. e1 .gt. 1.) then           !Find main velocity
          goto 60                                       ! component
        else if (e2 .ge. e1 .and. e2 .gt. 1.) then
          goto 30
        else
          goto 10
        end if

!------------------------------ END MAIN LOOP --------------------------------*
100     continue 
105		continue

        return                                          !Normal completion
110     return 1                                        !Emergency exit

        end subroutine track

        SUBROUTINE IMPACT (nvx, nvy, nvz, *, *, *)
!*******************************************************************************
!       IIIIII  MM    MM  PPPPP    AAAA    CCCC   TTTTTT                       *
!         II    M M  M M  P    P  A    A  C    C    TT                         *
!         II    M  MM  M  PPPPP   AAAAAA  C         TT                         *
!         II    M      M  P       A    A  C    C    TT                         *
!       IIIIII  M      M  P       A    A   CCCC     TT                         *
!*******************************************************************************
		use multicalc_params 
		implicit none 
 
!	  common /ion_abs/  xpr, ypr, zpr, kxpr, kypr, kzpr 
!     1         /ion_rel/  xr, yr, zr, d, u, iat 
!     1         /goniome/  sinphi, cosphi, sinth, costh, tanth 
!     1                  , coscos, cossin, sincos, sinsin 
!     1                  , tancos, tansin 
!     1         /ran_dis/  xt, yt, zt
 
   		integer		:: hitprob_deflect,ivx,nvx,nvy,nvz 
		integer		:: ivy,ivz,jat,nhulp,ist,ivi  
		real		:: dred,dred1,u_xt,u_yt,u_zt 
		real		:: xr0,yr0,zr0,xt1,yt1,zt1,xr1,yr1,zr1 
		real		:: u1,v1,d1,pns,em 
		real		:: u_con,v_con,u_hit,v_hit,u_vib,v_vib 
		real		:: random

        iat = 0
        dred = 1000.
!Unit random thermal displacements 
		call random_number(random) 
        u_xt = gauss(nint(2000.*random))  
		call random_number(random)
        u_yt = gauss(nint(2000.*random))             
		call random_number(random)
        u_zt = gauss(nint(2000.*random))

!-------------------------- LOOP OVER LATTICE POINTS --------------------------*
        do ivx = 1,nvx                                  !Search for atom on
          do ivy = 1,nvy                                ! location (ivx,ivy,ivz)
            do ivz = 1,nvz
              jat = lattice(lx(ivx), ly(ivy), lz(ivz))
              if (jat .eq. 0) goto 10

              xr0 = xpr-x(jat)+x_shift(ivx)             !Relative ion coord.
              yr0 = ypr-y(jat)+y_shift(ivy)             ! (xr1,yr1,zr1)
              zr0 = zpr-z(jat)

              xt1 = u_xt*sig(jat)                       !Thermal displacement of
              yt1 = u_yt*sig(jat)                       ! atom jat
              zt1 = u_zt*sig(jat)

              xr1 = xr0-xt1                             !New relative position
              yr1 = yr0-yt1                             ! of the ion
              zr1 = zr0-zt1

              u1 = xr1*coscos+yr1*cossin-zr1*sinth      !Projections normal to
              v1 = yr1*cosphi-xr1*sinphi                ! ion track
              d1 = u1*u1+v1*v1                          !Square of imp.parameter
              nhulp = ntypat(jat)
              dred1 = d1*d_max2(nhulp)                  !Reduced sq. imp.par.

!             Is atom 'jat' closer than previous atoms? And if so, is it also
!             close enough for a non-negligible deflection?
              if (dred1 .gt. dred) goto 10

!------------------------------- COLLISION PARTNER ----------------------------*
              iat = jat                                 !Closest atom iat:
              dred = dred1                              ! reduced sq. imp.par.
              d = d1                                    ! square of impact par.
              u = u1                                    ! impact coordinate
              xr = xr1                                  ! relative x, y and z
              yr = yr1                                  ! coordinates of the ion
              zr = zr1                                  ! and
              xt = xt1                                  ! thermal displacements
              yt = yt1                                  ! in x, y and z
              zt = zt1                                  ! directions

              u_con = xr0*coscos+yr0*cossin-zr0*sinth   !Projected relative ion
              v_con = yr0*cosphi-xr0*sinphi              ! position wrt eq.pos.
!Projected relative ion position with respect to equilibrium 
! position, corrected for impact parameter
              u_hit = (xr0-x_imp(ntypat(jat)))*coscos		&
                     +(yr0-y_imp(ntypat(jat)))*cossin   	&
                     -(zr0-z_imp(ntypat(jat)))*sinth    
              v_hit = (yr0-y_imp(ntypat(jat)))*cosphi		&
                     -(xr0-x_imp(ntypat(jat)))*sinphi   
 
!Projected thermal displacement
              u_vib = xt1*coscos+yt1*cossin-zt1*sinth   
              v_vib = yt1*cosphi-xt1*sinphi             

10            continue

!------------------------ END LOOP OVER LATTICE POINTS ------------------------*
            end do
          end do
        end do

        if (iat .eq. 0) return 1                        !No collision partner

!---------------------------TREATMENT OF CLOSEST ATOM--------------------------*
!       Four situations are possible:
!       - The ion passes the equilibrium position of atom 'iat' close enough for
!         a non-negligible contribution to the hitting probabilities, and it
!         passes the actual (= thermally displaced) position of the atom close
!         enough to be deflected over a non-negligible angle.
!       - The ion passes the equilibrium position of atom 'iat' close enough for
!         a non-negligible contribution to the hitting probabilities, but it
!         passes the actual (= thermally displaced) position of the atom too far
!         to be deflected over a non-negligible angle 
!       - The ion passes the equilibrium position of atom 'iat' too far for a
!         non-negligible contribution to the hitting probabilities, but it
!         passes the actual (= thermally displaced) position of the atom close
!         enough to be deflected over a non-negligible angle.
!       - The ion passes the equilibrium position of atom 'iat' too far for a
!         non-negligible contribution to the hitting probabilities, and it
!         passes the actual (= thermally displaced) position of the atom too far
!         to be deflected over a non-negligible angle.

        hitprob_deflect = 1
!Is atom iat too far for contr. to hit.probs.?
        if (u_hit**2+v_hit**2 .gt. h_max2(iat)) hitprob_deflect = 3                      
!Is atom iat too far for deflection?
        if (dred .gt. 1.) hitprob_deflect = hitprob_deflect+1                     
        goto (20, 30, 40, 50), hitprob_deflect

!		-------------------------HITTING PROBS. AND DEFLECTION------------------------* 
!Positions and vib.amps.same in all structure vibration models
20      if (i_differ(iat) .eq. 1) then                  
          em = expo(int(-(u_hit**2+v_hit**2)*sig2(iat)))  
          do ist = 1, nst
            do ivi = 1, nvi						
              hit_det(ivi, ist, iat) =			&
              hit_det(ivi, ist, iat)			&
             +contri(ivi, ist)*em
            end do
          end do
!Positions same, but vibration amplitudes different
        else if (i_differ(iat) .eq. 2) then             
          do ivi = 1, nvi                               
            do ist = 1, nst               
              hit_det(ivi, ist, iat) =			&
             hit_det(ivi, ist, iat)				&
             +contri(ivi, ist)				    & 
	         *expo(int(-(u_hit**2+v_hit**2)		&
             *vib2(ivi, iat)))

             contri(ivi, ist) =					&
             contri(ivi, ist)					&
             *expo(int((u_vib**2+v_vib**2)		&
             *(sig2(iat)-vib2(ivi, iat))))		&
             *vibquo(ivi, iat)
            end do
          end do

!Only vertical position! differences; vibration amplitudes same 
        else if (i_differ(iat) .eq. 3) then             
          do ist = 1, nst                               
            do ivi = 1, nvi                    	
              hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int								&
             (-((u_hit+rel_z(ist, iat)*sinth)**2	&
             +v_hit**2)								&
             *vib2(1, iat)))

             contri(ivi, ist) =						&
             contri(ivi, ist)						&
             *expo(int((u_vib**2+v_vib**2)			&
             *sig2(iat)								&
             -((u_vib+rel_z(ist, iat)*sinth)**2		&
             +v_vib**2)								&
             *vib2(1, iat)))						&
             *vibquo(1, iat)
            end do
          end do

        else if (i_differ(iat) .eq. 4) then             !Only vertical position
          do ist = 1, nst                               ! differences; vibration
            do ivi = 1, nvi                             ! amplitudes different
              hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int								&
             (-((u_hit+rel_z(ist, iat)*sinth)**2	&
             +v_hit**2)								&
             *vib2(ivi, iat)))

             contri(ivi, ist) =						&
             contri(ivi, ist)						&
             *expo(int((u_vib**2+v_vib**2)			&
             *sig2(iat)								&
             -((u_vib+rel_z(ist, iat)*sinth)**2		&
             +v_vib**2)								&
             *vib2(ivi, iat)))						&
             *vibquo(ivi, iat)
            end do
          end do

        else if (i_differ(iat) .eq. 5) then             !Lateral positions
          do ist = 1, nst                               ! different; vibration
            do ivi = 1, nvi                             ! amplitudes same
             hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int								&
             (-( (u_hit								&
             -rel_x(ist, iat)*coscos				&
             -rel_y(ist, iat)*cossin				&
             +rel_z(ist, iat)*sinth)**2				&
             +(v_hit								&
             +rel_x(ist, iat)*sinphi				&
             -rel_y(ist, iat)*cosphi)**2)			&
             *vib2(1, iat)))

             contri(ivi, ist) =						&
            contri(ivi, ist)						&
            *expo(int((u_vib**2+v_vib**2)			&
            *sig2(iat)								&
            -((u_vib								&
            -rel_x(ist, iat)*coscos					&
            -rel_y(ist, iat)*cossin					&
            +rel_z(ist, iat)*sinth)**2				&
            +(v_vib									&
            +rel_x(ist, iat)*sinphi					&
            -rel_y(ist, iat)*cosphi)**2)			&
             *vib2(1, iat)))						&
             *vibquo(1, iat)
            end do
          end do

        else if (i_differ(iat) .eq. 6) then             !Lateral positions and
          do ist = 1, nst                               ! vibration amplitudes
            do ivi = 1, nvi                             ! different
              hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int								&
             (-((u_hit								&
             -rel_x(ist, iat)*coscos				&
             -rel_y(ist, iat)*cossin				&
             +rel_z(ist, iat)*sinth)**2				&
             +(v_hit								&
             +rel_x(ist, iat)*sinphi				&
             -rel_y(ist, iat)*cosphi)**2)			&
             *vib2(ivi, iat)))

             contri(ivi, ist) =						&
             contri(ivi, ist)						&
             *expo(int((u_vib**2+v_vib**2)			&
             *sig2(iat)								&
             -((u_vib								&
             -rel_x(ist, iat)*coscos				&
             -rel_y(ist, iat)*cossin				&
             +rel_z(ist, iat)*sinth)**2				&
             +(v_vib								&
             +rel_x(ist, iat)*sinphi				&
             -rel_y(ist, iat)*cosphi)**2)			&
             *vib2(ivi, iat)))						&
             *vibquo(ivi, iat)
            end do
          end do

        end if
        goto 60

!-----------------------HITTING PROBS. BUT NO DEFLECTION-----------------------* 
!Positions and vibration amplitudes same in alL structure/vibration  models
30      if (i_differ(iat) .eq. 1) then                  
          em = expo(int(-(u_hit**2+v_hit**2)*sig2(iat)))       
          do ist = 1, nst                      
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)*em
            end do
          end do
!Positions same; but ! vibration amplitudes          ! differ
        else if (i_differ(iat) .eq. 2) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)  
          do ivi = 1, nvi
            do ist = 1, nst
              hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int(-(u_hit**2+v_hit**2)			&
             *vib2(ivi, iat)))

             contri(ivi, ist) =						&
             contri(ivi, ist)						&
             *pnvib(iroot(int(10000.				&
             *(u_con**2+v_con**2))), ivi, iat)		&
             *pns
            end do
          end do
!Only vertical position! differences; vibration      ! amplitudes different
        else if (i_differ(iat) .eq. 3) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)      
          do ist = 1, nst
            do ivi = 1, nvi
             hit_det(ivi, ist, iat) =				&
             hit_det(ivi, ist, iat)					&
             +contri(ivi, ist)						&
             *expo(int								&
             (-((u_hit+rel_z(ist, iat)*sinth)**2	&
             +v_hit**2)								&
             *vib2(1, iat)))

             contri(ivi, ist) =						&
             contri(ivi, ist)						&
             *pnvib(iroot(int(10000.*				&
             ((u_con+rel_z(ist, iat)*sinth)**2		&
             +v_con**2))), 1, iat)					&
             *pns
            end do
          end do
!Vertical position! differences, and! different vibration! amplitudes
        else if (i_differ(iat) .eq. 4) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst                               
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =						&
            hit_det(ivi, ist, iat)							&
            +contri(ivi, ist)								&
            *expo(int(-((u_hit+rel_z(ist, iat)*sinth)**2	&
            +v_hit**2)*vib2(ivi, iat)))

              contri(ivi, ist) =							&
             contri(ivi, ist)								&
             *pnvib(iroot(int(10000.*						&
             ((u_con+rel_z(ist, iat)*sinth)**2				&
             +v_con**2))), ivi, iat)						&
             *pns
            end do
          end do
!Lateral positions different; vibration amplitudes same.
        else if (i_differ(iat) .eq. 5) then             
          pns = pnsig(iroot(int(10000*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =					&
             hit_det(ivi, ist, iat)						&
             +contri(ivi, ist)							&
             *expo(int									&
             (-( (u_hit									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_hit									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)				&
             *vib2(1, iat)))
														
             contri(ivi, ist) =							&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_con									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2))), 1, iat)	&
             *pns
            end do
          end do
!Lateral position as well as vibration amplitudes different
        else if (i_differ(iat) .eq. 6) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =					&
             hit_det(ivi, ist, iat)						&
             +contri(ivi, ist)							&
             *expo(int									&
             (-((u_hit									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_hit									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)				&
             *vib2(ivi, iat)))

              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_con									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)))				&
             , ivi, iat)								&
             *pns
            end do
          end do

        end if
        return 1

!-----------------------DEFLECTION BUT NO HITTING PROBS.-----------------------* 
!Pos. and vib.amps. same
40      if (i_differ(iat) .eq. 1) then                  
          continue
!Positions same, but! vibration amplitudes              ! different
        else if (i_differ(iat) .eq. 2) then             
          do ivi = 1, nvi                               
            do ist = 1, nst               
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *expo(int((u_vib**2+v_vib**2)				&
             *(sig2(iat)-vib2(ivi, iat))))				&
             *vibquo(ivi, iat)
            end do
          end do
!Only vertical position! differences; vibration ! amplitudes same
        else if (i_differ(iat) .eq. 3) then             
          do ist = 1, nst                               
            do ivi = 1, nvi                    
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *expo(int((u_vib**2+v_vib**2)				&
             *sig2(iat)									&
             -((u_vib+rel_z(ist, iat)*sinth)**2			&
             +v_vib**2)									&
             *vib2(1, iat)))							&
             *vibquo(1, iat)
            end do
          end do
!Vertical positions as! well as vibration               ! amplitudes differ
        else if (i_differ(iat) .eq. 4) then             
          do ist = 1, nst                               
            do ivi = 1, nvi              
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *expo(int((u_vib**2+v_vib**2)				&
             *sig2(iat)									&
             -((u_vib+rel_z(ist, iat)*sinth)**2			&
             +v_vib**2)									&
             *vib2(ivi, iat)))							&
             *vibquo(ivi, iat)							
            end do
          end do
!Lateral position! differences; vibration amplitudes same
        else if (i_differ(iat) .eq. 5) then             
          do ist = 1, nst                               
            do ivi = 1, nvi              
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *expo(int((u_vib**2+v_vib**2)				&
             *sig2(iat)									&
             -((u_vib									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_vib									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)				&
             *vib2(1, iat)))							&
             *vibquo(1, iat)
            end do
          end do

        else if (i_differ(iat) .eq. 6) then             !Lateral positions as
          do ist = 1, nst                               ! well as vibration
            do ivi = 1, nvi                             ! amplitudes differ
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *expo(int((u_vib**2+v_vib**2)				&
            *sig2(iat)									&
             -((u_vib									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_vib									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)				&
             *vib2(ivi, iat)))							&
             *vibquo(ivi, iat)
            end do
          end do

        end if
        goto 60

!----------------------NO HITTING PROBS. AND NO DEFLECTION---------------------*
50      if (i_differ(iat) .eq. 1) then                  !Pos. and vib.amps. same
          continue
!Positions same; but! vibration amplitudes           ! different
        else if (i_differ(iat) .eq. 2) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat) 
          do ivi = 1, nvi
            do ist = 1, nst
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.					&
             *(u_con**2+v_con**2))), ivi, iat)			&
             *pns
            end do
          end do
!Only vertical position! differences; vibration! ampliudes same
        else if (i_differ(iat) .eq. 3) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con+rel_z(ist, iat)*sinth)**2			&
             +v_con**2))), 1, iat)						&
             *pns
            end do
          end do
!Vertical positions as! well as vibration! amplitudes differ
        else if (i_differ(iat) .eq. 4) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con+rel_z(ist, iat)*sinth)**2			&
             +v_con**2))), ivi, iat)					&
             *pns
            end do
          end do
!Lateral position! differences; vibration! amplitudes same
        else if (i_differ(iat) .eq. 5) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)            
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_con									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2))), 1, iat)	&
             *pns
            end do
          end do
!Lateral positions as! well as vibration amplitudes differ
        else if (i_differ(iat) .eq. 6) then             
          pns = pnsig(iroot(int(10000.*(u_con**2+v_con**2))), iat)
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =						&
             contri(ivi, ist)							&
             *pnvib(iroot(int(10000.*					&
             ((u_con									&
             -rel_x(ist, iat)*coscos					&
             -rel_y(ist, iat)*cossin					&
             +rel_z(ist, iat)*sinth)**2					&
             +(v_con									&
             +rel_x(ist, iat)*sinphi					&
             -rel_y(ist, iat)*cosphi)**2)))				&
             , ivi, iat)								&
             *pns
            end do
          end do

        end if
        return 1

!------------------------------- DEFLECTION -----------------------------------*
60      call collision (*70)                            !Deflection
        return 2                                        !Normal deflection
70      return 3                                        !Backscattering

        end subroutine impact

        SUBROUTINE COLLISION (*)
!*******************************************************************************
!        CCCC    OOOO   LL      LL      IIIIII   SSSSS  IIIIII   OOOO   NN    N*
!       C    C  O    O  LL      LL        II    S         II    O    O  N N   N*
!       C       O    O  LL      LL        II     SSSS     II    O    O  N  N  N*
!       C    C  O    O  LL      LL        II         S    II    O    O  N   N N*
!        CCCC    OOOO   LLLLLL  LLLLLL  IIIIII  SSSSS   IIIIII   OOOO   N    NN*
!*******************************************************************************
		use multicalc_params 
		implicit none 
		real	:: t,tan_def,s,delfac,a,b 
!		write(*,*) 'Collision' 
!Impact parameter 
        t = sqrt(d)                                     

!       Deflection angle xphi: 
!Tangent of deflection! angle
        tan_def = deflection(ntypat(iat), nint(2000.*t))                        

        s = u*tanth
        delfac = tan_def/(t-s*tan_def)
!Stop track in case of backscattering
        if (delfac .lt. 0.) return 1                    
                                                       
!       Relative coordinates with respect to atom iat of point with z-coordinate
!       equal to that of atom iat: 

        xr = xr-zr*tancos
        yr = yr-zr*tansin
!Absolute coordinates of inflection point
        xpr = xr+xt+x(iat)-sincos*s                     
        ypr = yr+yt+y(iat)-sinsin*s                     
        zpr =    zt+z(iat)-costh *s
        kxpr = kx(iat)
        kypr = ky(iat)
        kzpr = kz(iat)
!Distances for new goniometry
        a = sincos+delfac*xr                            
        b = sinsin+delfac*yr                            

        call direction (a, b, costh)
        call new_gonio
!		write(*,*) 'End collisiion'
        return
        end subroutine collision

        SUBROUTINE DIRECTION (a, b, c)
!*******************************************************************************
!       DDDDD   IIIIII  RRRRR   EEEEEE   CCCC   TTTTTT  IIIIII   OOOO   NN    N*
!       D    D    II    R    R  E       C    C    TT      II    O    O  N N   N*
!       D    D    II    RRRRR   EEEEEE  C         TT      II    O    O  N  N  N*
!       D    D    II    R  R    E       C    C    TT      II    O    O  N   N N*
!       DDDDD   IIIIII  R   R   EEEEEE   CCCC     TT    IIIIII   OOOO   N    NN*
!*******************************************************************************
		use multicalc_params 
		implicit none 
		real :: a,b,c,e 
!		write(*,*) 'Direction' 
        d = sqrt(a**2+b**2)
        if (d .eq. 0.) d = 1.e-6
        e = sqrt(a**2+b**2+c**2)
        if (e .eq. 0.) e = 1.e-6

        cosphi = a/d
        sinphi = b/d
        costh  = c/e
        sinth  = d/e
        coscos = costh*cosphi
        cossin = costh*sinphi
        sincos = sinth*cosphi
        sinsin = sinth*sinphi
!		write(*,*) 'End direction'
        return
        end subroutine direction

        SUBROUTINE NEW_GONIO
!*******************************************************************************
!*       NN    N  EEEEEE  WW      W       GGGG    OOOO   NN    N  IIIIII   OOOO *
!*       N N   N  E        WW     W      G    G  O    O  N N   N    II    O    O*
!*       N  N  N  EEEEEE    WW WW W      G       O    O  N  N  N    II    O    O*
!*       N   N N  E          WWWWWW  --- G   GG  O    O  N   N N    II    O    O*
!*       N    NN  EEEEEE      WW WW  ---  GGGGG   OOOO   N    NN  IIIIII   OOOO *
!********************************************************************************
		use multicalc_params 
		implicit none 
		integer  :: ivi,ist,iel 
		real     ::	real_cs_old,sinan,cosan 
!		write(*,*) 'gonio' 
        if (costh .ne. 0.) then
          tanth  = sinth/costh
        else
          tanth = sinth*1.e-6
        end if
        tancos = tanth*cosphi
        tansin = tanth*sinphi
        isignx = int(sign(1., cosphi))
        isigny = int(sign(1., sinphi))
        cosan = sico2*sincos+sisi2*sinsin+coth2*costh
        sinan = sqrt(1.-cosan*cosan)

        real_cs_old = real_cs
        real_cs = 1./((cosan-1.)**2)

        do ivi = 1,nvi
          do ist = 1,nst
            contri(ivi, ist) = contri(ivi, ist)*real_cs/real_cs_old
          end do
        end do

        do iel = 1, nel
          x_imp(iel) = sc_imp_par(iel)*(sico2-cosan*sincos)/sinan
          y_imp(iel) = sc_imp_par(iel)*(sisi2-cosan*sinsin)/sinan
          z_imp(iel) = sc_imp_par(iel)*(coth2-cosan*costh )/sinan
        end do
        e1 = abs(tancos)
        e2 = abs(tansin)
!		write(*,*) 'End gonio'
        return
        end subroutine new_gonio

        SUBROUTINE SEEK_PLANE (plane, nr_of_planes, position, i_plane)
!*******************************************************************************
!*        SSSSS  EEEEEE  EEEEEE  K    K       PPPPP   LL       AAAA   NN    N   *
!*       S       E       E       K  KK        P    P  LL      A    A  N N   N   *
!*        SSSS   EEEEEE  EEEEEE  KKK          PPPPP   LL      AAAAAA  N  N  N   *
!*            S  E       E       K  KK   ---  P       LL      A    A  N   N N  .*
!*       SSSSS   EEEEEE  EEEEEE  K    K  ---  P       LLLLLL  A    A  N    NN  .*
!********************************************************************************
		implicit none 
		integer ::  nr_of_planes,i_plane 
        real	::	plane(nr_of_planes),test,position 
!		write(*,*) 'seek' 
        test = position - plane(i_plane) 
 
  		if (test .lt. 0.) then 
 
			do while (plane(i_plane - 1) .gt. position) 
				i_plane = i_plane-1 
			end do 
 
		else if (test .eq. 0) then 
			i_plane = min (i_plane + 1, nr_of_planes) 
        else 
			i_plane = i_plane + 1 
		    do while (plane(i_plane) .lt. position) 
			    i_plane = i_plane + 1 
			end do 
		end if 
!		write(*,*) 'end seek'
        end subroutine seek_plane

        SUBROUTINE PERIOD_BOUND (position, period)
!********************************************************************************
!*       PPPPP   EEEEEE  RRRRR   IIIIII   OOOO   DDDDD        BBBBB    OOOO     *
!*       P    P  E       R    R    II    O    O  D    D       B    B  O    O    *
!*       PPPPP   EEEEEE  RRRRR     II    O    O  D    D       BBBBB   O    O    *
!*       P       E       R  R      II    O    O  D    D  ---  B    B  O    O  ..*
!*       P       EEEEEE  R   RR  IIIIII   OOOO   DDDDD   ---  BBBBB    OOOO   ..*
!********************************************************************************
		IMPLICIT NONE 
		real :: shift,position,period 
!		write(*,*) 'period' 
        shift		= -period*nint(position/period-0.5)
        position	=  position+shift
!		write(*,*) 'end period' 
        return
        end	subroutine period_bound

        SUBROUTINE POTENT
!********************************************************************************
!*       PPPPP    OOOO   TTTTTT  EEEEEE  NN    N  TTTTTT                        *
!*       P    P  O    O    TT    E       N N   N    TT                          *
!*       PPPPP   O    O    TT    EEEEEE  N  N  N    TT                          *
!*       P       O    O    TT    E       N   N N    TT                          *
!*       P        OOOO     TT    EEEEEE  N    NN    TT                          *
!********************************************************************************
	use multicalc_params 
	IMPLICIT NONE 
	real :: weight,v,f,g,ang1,ang2,s,qm,l,r 
	real :: ener,relen 
	integer i_defl,iel,i 
!		write(*,*) 'potent' 
        ener = el_loss_fac*energy                       !Elastic energy loss 
        zi   = nzi                                        !Ion atomic number 
 
element : do iel = 1,nel 
          ztarg = nzt(iel)                                 !Target atomic number 
          qm = rmi/rmt(iel)                             !Ion/target mass ratio 
          relen = ener*rmt(iel)/(rmt(iel)+rmi)          !Relative energy (29/6/87) 
          call screening_length                         !Evaluate scrlen 
          coulomb = .014402*ztarg*zi		 
          deflection(iel, 0) = -1.E-6 
s_parm :  do i_defl = 1,10000 
            s = i_defl/2000.                        !Impact parameter 
            r = rclose(s, relen)                    !Dist. of closest appr. 
            deflection(iel, i_defl) = 0.            !Numerical evaluation of 
													! the collision integral 
			f=0.0 
integrate :	do i=1,30 
			l=30.0-i+1 
			ang1=(2.*l-1)*(pi/120.0) 
			ang2=(2.*i-1)*(pi/120.0) 
			weight=cos(ang1) 
			v=cos(ang2) 
			g=1.0/sqrt(1-(pot(r/v)/relen)-((s**2)*(v**2)/(r**2))) 
			f=f+(weight*g) 
		end do integrate 
 
        f=f*pi/(60.0*r) 
        deflection(iel, i_defl) =pi-2.*s*f 
 
!       Conversion CM-system -> LAB-system. Subroutine 'COLLISION' only 
!       needs the tangent of the LAB-deflection angle: 
 
        deflection(iel, i_defl)=sin(deflection(iel, i_defl))/(cos(deflection(iel,i_defl))+qm) 
		end do s_parm 
        end do element 
!		write(*,*) 'end potent' 
        return 
        end subroutine potent

        FUNCTION RCLOSE (s, relen)
!*******************************************************************************
!       RRRRR    CCCC   LL       OOOO    SSSSS  EEEEEE                         *
!       R    R  C    C  LL      O    O  S       E                              *
!       RRRRR   C       LL      O    O   SSSS   EEEEEE                         *
!       R  R    C    C  LL      O    O       S  E                              *
!       R   R    CCCC   LLLLLL   OOOO   SSSSS   EEEEEE                         *
!*******************************************************************************
		IMPLICIT NONE 
!		Find distance of closest approach rclose 
!		i.e value of r when f=1-s^2/r^2-pot(r)/E =0  
        real:: step,f 
		real:: rclose,r,s,relen 
!		write(*,*) 'rclose' 
        r = s 
        step = .1 
		do while(step>1.E-8) 
		f = 1.-s*s/(r*r)-pot(r)/relen 
		if(f<0.) then 
		r=r+step 
		else 
		step=step*0.5 
		r=r-step 
		endif 
		end do 
        rclose = r-step*0.5 
!		write(*,*) 'end rclose' 
        return
        end function rclose

        FUNCTION POT (r)
!********************************************************************************
!*       PPPPP    OOOO   TTTTTT                                                 *
!*       P    P  O    O    TT                                                   *
!*       PPPPP   O    O    TT                                                   *
!*       P       O    O    TT                                                   *
!*       P        OOOO     TT                                                   *
!********************************************************************************
	use multicalc_params 
	IMPLICIT NONE 
	real ::		r,r_redt,pot 
!		write(*,*) 'pot' 
        pot		= coulomb/r 
        r_redt		= r*scrlen 
 
		potential: select case (mode(3)) 
		case(0) 
          pot		= pot*			& 
			& (.10*exp(-6.0*r_redt)	& 
			& +.55*exp(-1.2*r_redt)	&	 
			& +.35*exp(-0.3*r_redt)) 
 
		case(1) 
          pot		= pot*				& 
			& (.1818  *exp(-3.2*r_redt)	& 
			& +.5099  *exp(-0.9423*r_redt)	& 
			& +.2802  *exp(-0.4029*r_redt)	& 
			& +.02817 *exp(-0.2016*r_redt)) 
		 
		end select potential		 
!		write(*,*) 'end pot' 
		return 
        end function pot
 
        SUBROUTINE SCAT_IMP (angle, dist) 
!******************************************************************************** 
!*        SSSSS   CCCC    AAAA   TTTTTT       IIIIII  MM    MM  PPPPP           * 
!*       S       C    C  A    A    TT           II    M M  M M  P    P          * 
!*        SSSS   C       AAAAAA    TT           II    M  MM  M  PPPPP           * 
!*            S  C    C  A    A    TT    ---    II    M      M  P               * 
!*       SSSSS    CCCC   A    A    TT    ---  IIIIII  M      M  P               * 
!******************************************************************************** 
! 
! returns scattering impact parameter for a given element for a given angle 
! by looking angle up in the deflection table. 
 
	 
	use multicalc_params 
	IMPLICIT NONE 
	real:: dist(nel) 
	real:: angle,deflect 
	integer:: i_defl,iel 
	logical:: found 
!    write(*,*) 'scat imp' 
 
        do iel = 1,nel                                   
		found=.FALSE. 
        i_defl		= 0                                     
		do while(.not.found) 
		  found=.TRUE. 
          deflect= atan(deflection(iel, i_defl))		   
		  if (deflect < 0.)	 deflect = deflect+pi 
          if (deflect > angle) then 
			i_defl= i_defl+1 
			found=.FALSE. 
		   endif 
		end do 
         dist(iel) = i_defl/2000. 
        end do 
!		write(*,*) 'end scat imp' 
        return 
        end subroutine scat_imp 


        SUBROUTINE EXCLUSION
!********************************************************************************
!*       EEEEEE  XX   XX   CCCC   LL      U    U   SSSSS  IIIIII   OOOO   NN    *
!*       E        XX XX   C    C  LL      U    U  S         II    O    O  N N   *
!*       EEEEEE    XXX    C       LL      U    U   SSSS     II    O    O  N  N  *
!*       E        XX XX   C    C  LL      U    U       S    II    O    O  N   N *
!*       EEEEEE  XX   XX   CCCC   LLLLLL   UUUU   SSSSS   IIIIII   OOOO   N    N*
!********************************************************************************
		use multicalc_params 
		implicit none 
		integer :: idis,ivi,ir,i 
		real	:: dis,pouts,disdif,delta,r,alfa 
        do iat = 1,mav 
!Maximum imp. par for a deflection
          dmax = sqrt(1./d_max2(ntypat(iat)))           
          idis = 0                                      

10        idis = idis+1
          if (idis .gt. 650) goto 20 
!Distance to equilibrium position
          dis = idis/100.                               
          pnsig(idis, iat) = 0.                         
          pouts = 1.
          do ivi = 1,nvi
            pnvib(idis, ivi, iat) = 0.
            poutv(ivi) = 1.
          end do
          disdif = dmax-dis 
!Eq. pos. close enough for a deflection
          if (disdif .gt. 0.) then                      
            delta = dis/75.                              
!Probs. for finding atom ! iat outside circle with radius 'dmax-dis'around eq. position
            pouts = expo(-min(25000,nint(sig2(iat)*disdif**2)))           
            do ivi = 1,nvi                              
              poutv(ivi) = expo(-min(25000,nint(vib2(ivi, iat)*disdif**2)))
            end do
!Loop over remaining part of circle with radius 'dmax' and  
!with centre 'dis' away from the equilibrium pos 
            do ir = 1,150                               
              r = (ir-0.5)*delta+disdif                 
              alfa = acos((r**2+dis**2-dmax**2)/(2.*r*dis))                            
              pnsig(idis, iat) = pnsig(idis, iat)       &
		      +expo(-min(25000							&
             , nint(sig2(iat)*r**2)))*alfa*r
              do ivi = 1,nvi
                pnvib(idis, ivi, iat) =					&
                      pnvib(idis, ivi, iat)				&
                     +expo(-min(25000					&
                     , nint(vib2(ivi, iat)*r**2)))		&
                     *alfa*r
              end do
            end do
          else                                           
!Eq. pos. too far for a  deflection 
!Loop over circle with radius 'dmax' and with 
! centre 'dis' away from! the equilibrium pos.
            delta = dmax/75.                            
            do ir = 1,150                               
              r = (ir-0.5)*delta-disdif                 
              alfa = acos((r**2+dis**2-dmax**2)/(2.*r*dis))                            
              pnsig(idis, iat) = pnsig(idis, iat)		&
              +expo(-min(25000							&
             , nint(sig2(iat)*r**2)))*alfa*r
              do ivi = 1,nvi
                pnvib(idis, ivi, iat) =					&
                      pnvib(idis, ivi, iat)				&
                     +expo(-min(25000					&
                    , nint(vib2(ivi, iat)*r**2)))		&
                     *alfa*r
              end do
            end do
          end if 
!Probs. for atom iat to! be outside circle with! radius 'dmax' and with 
! centre 'dis' away from! the equilibrium! position
          pnsig(idis, iat) = 1./max(1.e-34				&     
             , pouts-2.*pnsig(idis, iat)             	&
             *delta*sig2(iat)/125./pi)               
          do ivi = 1,nvi                                
            pnvib(idis, ivi, iat) = max(1.e-34,         &
             poutv(ivi)-2.*pnvib(idis, ivi, iat)     	&
            *delta*vib2(ivi, iat)/125./pi)
          end do
          if (pnsig(idis, iat) .ge. 1.01) goto 10
          do ivi = 1,nvi
            if (pnvib(idis, ivi, iat) .le. 0.99) goto 10
          end do
          if (idis .lt. 650) then
            do i = idis+1,650
              pnsig(i, iat) = 1.
              do ivi = 1,nvi
                pnvib(i, ivi, iat) = 1.
              end do
            end do
          end if
20        continue
        end do
        return
        end subroutine exclusion

        SUBROUTINE SCREENING_LENGTH
!********************************************************************************
!*       SSSSSS   CCCC  RRRR   EEEEE  EEEEE  N   N  II  N   N  GGGGGG         L *
!*       S       C      R   R  E      E      NN  N  II  NN  N  G              L *
!*       SSSSSS  C      RRRR   EEEE   EEEE   N N N  II  N N N  G  GGG         L *
!*            S  C      R   R  E      E      N  NN  II  N  NN  G    G ------- L *
!*       SSSSSS   CCCC  R   R  EEEEE  EEEEE  N   N  II  N   N  GGGGGG ------- L *
!********************************************************************************
		use multicalc_params 
		implicit none 
        if (mode(3) .eq. 0) then                                 
		if ( zi .eq. 1.) then                              
                 scrlen = ( ztarg ** 0.333333333) / (0.88534*0.529) 
               else                                              
                scrlen = (0.5*zi)**0.5 + ztarg**0.5 
                scrlen = scrlen**0.666666667 
                scrlen = scrlen / (0.88534*0.529) 
               endif 
        else                                                     
	          scrlen = (zi**0.23+ztarg**0.23)/(0.88534*0.529) 
 
        endif 
 
        return 
        end subroutine screening_length
 
!		subroutine gaussian 
! ========================================== 
! Generates a general gaussian distribution 
! from which the vibrations are calculated 
! ========================================== 
!	use multicalc_params 
!	IMPLICIT NONE		 
!	REAL :: dx,dg,ix,grens,cum1,cum2,prefac,x1,x2 
!	INTEGER :: ig,choice 
	 
!        dx			= 0.0001                              
!        dg			= 0.0005                              
!        ig			= 1001                               
!        ix			= 0.0                                 
!        grens		= dg                              
!        cum1		= 0.0 
!        cum2		= 0.0 
!        prefac		= dx/sqrt(8.*atan(1.)) 
!	choice		= 1 
!	do while(ig.ne.2001) 
!	select case(choice) 
!		case(1) 
!			ix		= ix+1 
!			x1		= (ix-0.5)*dx 
!			x2		= ix*dx 
!			cum2		= cum1+exp(-x1*x1*.5)*prefac 
!			choice		= 2 
!		case(2) 
!		        if ((cum2-grens)<0.) then			 
!		        cum1		= cum2 
!		        choice		= 1 
!			else 
!			choice		= 3 
!			end if				 
!		case(3) 
!			gauss(ig)	= x2-dx*(cum2-grens)/(cum2-cum1) 
!			ig			= ig+1 
!			grens		= (ig-1000)*dg 
!			if (ig .eq. 2000) grens = grens-0.1*dg 
!			choice=2 
!		end select 
!		end do 
!        gauss(1001)   =  0.0 
!		gauss(0:999) = -gauss(1001:2000)	 
 
 
	 
!	end subroutine gaussian 
 
 
	end module multicalc_code
